<?php
class DeadlinesController extends AppController
{
	var $helpers = array("Form");

	var $uses = array("Deadline", "Round", "Aclusersmanufacturer", "Acluserscsvstore", "Report", "Deadlinereminder");

	var $paginate = array(
        'limit' => 70,
        'order' => array(
            'Deadline.id' => 'asc'
        )
    );

	// errinere reps per email an überschreitung der deadline
	function reminder() {
		// kein login nötig, ruft cron auf
		
		$current_round_id = $this->Round->getCurrentRoundID();
		$round = $this->Round->find("Round.id=".$current_round_id);
		
		$aclusersmanufacturers = $this->Aclusersmanufacturer->findAll();
		
		$acluserscsvstores = $this->Acluserscsvstore->findAll();
		
		
		// aktuelle und letzte runde holen
		$rounds = $this->Round->getLastNRounds(2);
		
		$whereClause="";
		foreach ($rounds as $round) {
			$whereClause .= " or round_id=" . $round["Round"]["id"];
		}
		$reports = $this->Report->findAll(" (0=1) " . $whereClause);
		
		$deadlinereminders = $this->Deadlinereminder->findAll(" (0=1) " . $whereClause);
		
		
		$mailTemplate = $this->Config->getConfigValue("deadlinereminder");
		
		// schleife über die letzte und die aktuelle runde
		foreach ($rounds as $round) {
			
			// schleife über alle stores
			foreach ($acluserscsvstores as $acluserscsvstore) {
			
				// schleife über alle user und märkte
				foreach ($aclusersmanufacturers as $aclusersmanufacturer) {
					// wenn zu dem store ein passender hersteller und markt gefunden wurde
					if ($acluserscsvstore["Acluserscsvstore"]["user_id"] == $aclusersmanufacturer["Aclusersmanufacturer"]["user_id"]) {
						// ja, hier ist runde, store, hersteller und markt bekannt
						
						
						// bereits ein report eingegeben?
						foreach ($reports as $report) {
							if (
								$report["Report"]["manufacturer_id"] == $aclusersmanufacturer["Aclusersmanufacturer"]["manufacturer_id"] &&
								$report["Report"]["round_id"] == $round["Round"]["id"] &&
								$report["Report"]["csvstore_id"] == $acluserscsvstore["Csvstore"]["id"] 
								
							) {
								// ja, es wurde schon ein report eingegeben -> keinen reminder verschicken
								@$reportstfundn++;
								break 2;
							} 
						}
						
						foreach ($deadlinereminders as $deadlinereminder) {
							if (
								$deadlinereminder["Deadlinereminder"]["manufacturer_id"] == $aclusersmanufacturer["Aclusersmanufacturer"]["manufacturer_id"] &&
								$deadlinereminder["Deadlinereminder"]["round_id"] == $round["Round"]["id"] &&
								$deadlinereminder["Deadlinereminder"]["csvstore_id"] == $acluserscsvstore["Csvstore"]["id"] 
								
							) {
								// ja, es wurde schon ein deadlinereminder verschickt -> keinen reminder mehr verschicken
								break 2;
							}
						}
						
						
						$personalizedEmail = str_replace("###SALUTATION###", 	$aclusersmanufacturer["User"]["salutation"], $mailTemplate);
						$personalizedEmail = str_replace("###FIRSTNAME###", 	$aclusersmanufacturer["User"]["first_name"], $personalizedEmail);
						$personalizedEmail = str_replace("###LASTNAME###",		$aclusersmanufacturer["User"]["last_name"], $personalizedEmail);

						$personalizedEmail = str_replace("###MANUFACTURER###",	$aclusersmanufacturer["Manufacturer"]["name"], $personalizedEmail);
						$personalizedEmail = str_replace("###CSVSTORE###",		$acluserscsvstore["Csvstore"]["uniqueExtID"], $personalizedEmail);
						$personalizedEmail = str_replace("###ROUND###",			$round["Round"]["description"], $personalizedEmail);
						
						
						
						$this->sendMail($aclusersmanufacturer["User"]["email"], "Avalon: Erinnerung wegen überschrittener Deadline", $personalizedEmail);
						@$sentMailCounter++;
						
						$deadlinereminder=array();
						$deadlinereminder["Deadlinereminder"]["id"]=0; // force new record in db
						$deadlinereminder["Deadlinereminder"]["manufacturer_id"]=$aclusersmanufacturer["Aclusersmanufacturer"]["manufacturer_id"];
						$deadlinereminder["Deadlinereminder"]["round_id"]=$round["Round"]["id"];
						$deadlinereminder["Deadlinereminder"]["csvstore_id"]=$acluserscsvstore["Csvstore"]["id"];
						$deadlinereminder["Deadlinereminder"]["user_id"]=$acluserscsvstore["Acluserscsvstore"]["user_id"];
						$deadlinereminder["Deadlinereminder"]["uts_sent"]=time();
						$deadlinereminder["Deadlinereminder"]["ip"]=$_SERVER['REMOTE_ADDR'];
						$this->Deadlinereminder->save($deadlinereminder);
					}
				}
			}
		}
		
		
		
			//if ($aclusersmanufacturer["Aclusersmanufacturer"]["user_id"] == 
			
			//$this->Report->findAll("round_id = " . $current_round_id . " and user_id= " . $aclusersmanufacturer["Aclusersmanufacturer"]["user_id"] . " and manufacturer_id = " . $aclusersmanufacturer["Aclusersmanufacturer"]["manufacturer_id"]
		//echo "sent: " . $sentMailCounter . " mails";
		//echo "tfunden: " . $tfundencount . "";
		//echo "reportstfundn: " . $reportstfundn . "";
		
		exit(0);
		
	}

	
}
?>
