<?php
class OrdersController extends AppController
{

	var $uses=array("Order", "User", "Manufacturer", "Distributor", "Csvstore", "Round", "Aclusersmanufacturer", "Acluserscsvstore", "Closedround");
	var $paginate = array(
        'limit' => 100,
        'order' => array(
            'Order.id' => 'asc'
        )
    );
	
	
	function export() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			// csv macht nur ohne debug-info von cake sinn, andernfals ist das csv malformed
			Configure::write('debug', '0');

			// alle datenstze ausgeben, paging deaktivieren
			//$this->paginate['limit'] = 0;

			// weies layout nehmen, damit kein html ins csv rutscht
			$this->layout = 'minimalistic';

			// alles exportieren, was show anzeigen wrde
			$this->show();
		}
	}


	function setisenabled($unsafe_isEnabled=true, $unsafe_id) {
		if ($this->requireAccess(true, array("rep", "accountmanager"))) {
			$id=(int)$unsafe_id;
			
			
			$isEnabled=(bool)$unsafe_isEnabled;	
			
			$order = $this->Order->find("Order.id=".$id);
			$order["Order"]["isEnabled"] = ($unsafe_isEnabled == "false") ?  'n'  : 'y';
			
			//print_r($order);
			//exit(0);
			if ($this->Order->save($order)) {
				$this->redirect("/orders/addorchange");
				//exit(0);
			} else {

				$this->flash("Fehler beim Speichern: " . $this->Order->data["BeforeSave"]["error"], "/orders/addorchange");
			}
		}
		
			
	}
	
	function show() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			$rounds = $this->Round->findAll("isEnabled='y' order by uts_round_until asc "  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id'], 0);
			
			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id'], 0);
			$this->set(compact('selectedmanufacturerid'));
				
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() . " AND Csvstore.isEnabled='y' order by uniqueExtID" );
			$this->set("csvstores", $assignedcsvstores);
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id'], 0);
			$this->set(compact('selectedcsvstoreid'));
			
			
			$whereClause="";
			if ($selectedroundid > 0) {
				$whereClause .= " and round_id=".$selectedroundid;
			}
			if ($selectedmanufacturerid > 0) {
				$whereClause .= " and manufacturer_id=".$selectedmanufacturerid;
			}
			if ($selectedcsvstoreid > 0) {
				$whereClause .= " and csvstore_id=".$selectedcsvstoreid;
			}
			
			$orders = $this->paginate('Order', array("1=1 " . $whereClause)  );
			
			// In diesem Array werden die Mrkte heraussortiert die bereits deaktiviert wurden
			$orders_tmp = array();
			foreach ($orders as $order) {
				
				if ($order["Csvstore"]["isEnabled"] == 'y') {
					//Elemente werden an Array angehngt, wichtig immer mit []
					$orders_tmp[] = $order;
				}
			}
			
			$this->set("orders", $orders_tmp);
			//$this->set(compact('orders'));
			
			//print_r($orders_tmp);
		}
		
	}
	function toggleisenabled($unsafe_id) {
		$id=(int)$unsafe_id;
		if ($this->requireAccess(true, array("accountmanager"))) {
			$order = $this->Order->find("Order.id=".$id);
			$order["Order"]["isEnabled"] = ($order["Order"]["isEnabled"] == "y") ? "n" : "y";
			if ($this->Order->save($order)) {
				$this->flash("Daten konnten gespeichert werden", "/orders/show");
			} else {
				$this->flash("Datenbankfehler! Bitte probieren Sie es zu einem spteren Zeitpunkt erneut", "/orders/show");
			}
			
		}
	}
	function addorchange($unsafe_id=NULL) {
		
		
		//print_r($this->params['data']);
		if ($this->requireAccess(true, array("rep", "accountmanager"))) {
		
			$id=(int)$unsafe_id;
			
			$sticky = array(); // dieses array wird in der view angezeigt
			if ($id>0) {
				// user will bestellung bearbeiten, nicht neu einfgen
				
				// prinzipell bearbeitet der user den wert in der datenbank
				$sticky = $this->Order->find("Order.id=".$id);
				
				// uts in human readable fr die gui nachbesern, quasi so tun als ob der user datum eingegeben htte
				$sticky["Order"]["orderdate"]=date("d.m.Y", $sticky["Order"]["uts_orderdate"]);
				
				// markt, hersteller und runde setzen
				$this->Session->write('Global.selectedroundid', $sticky["Order"]["round_id"]);
				$this->Session->write('Global.selectedmanufacturerid', $sticky["Order"]["manufacturer_id"]);
				$this->Session->write('Global.selectedcsvstoreid', $sticky["Order"]["csvstore_id"]);
				
				
			}
			
			// falls der user daten eingegeben hat wird der datenbankwert berschrieben (falls ein dbwert geladen wurde)
			if (isset($this->params['data'])) {
				foreach ($this->params["data"] as $key => $value) {
					$sticky[$key] = $value;			
				}
			}		
			$this->set(compact("sticky"));
			
		
		
			$this->set("getLoggedInRoleID",  $this->getLoggedInRoleID());
			$this->set("repRoleID", $this->getRoleIdByKey("rep"));
			$this->set("amRoleID", $this->getRoleIdByKey("accountmanager"));
			$this->set("userID", $this->getLoggedInUserID());
		
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until asc "  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			
			$this->set(compact('selectedroundid'));
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			//Uts_round_until der ausgewhlten Runde wird rausgefiltert
			$utsRoundUntil = $this->Round->getUtsRoundUntil($rounds, $selectedroundid);
			
			if ($this->requireAccess(false, array("accountmanager"))) {
				// accountmanager sieht alle seine Hersteller egal ab wann er diesem zugeteilt wurde
				$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
			} else {
				$aclusersmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
				// In Array $assignedmanufacturers werden alle Hersteller gespeichert die, in der ausgewhlten Runde, dem jeweiligen Rep zugeteilt waren.
				$assignedmanufacturers =  $this->getAssignedManufacturers($aclusersmanufacturers, $utsRoundUntil);
			}
			$this->set("assignedManufacturers", $assignedmanufacturers);
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 1, $this->extractIDs($assignedmanufacturers, "Manufacturer"));
			$this->set(compact('selectedmanufacturerid'));
			
			
			
			if ($this->requireAccess(false, array("accountmanager"))) {
				// accountmanager sieht alle mrkte weil ihm ja kein spezieller markt zugewiesen ist, Ausnahme deaktivierte Mrtke
				$assignedcsvstores =  $this->Csvstore->findAll("Csvstore.isEnabled='y'");
			} else {
				// user ist ein rep, der sieht nur die ihm zugetilten mrkte
				$acluserscsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() . " order by uniqueExtID" );
				// In Array $assignedcsvstores werden alle Stores gespeichert die, in der ausgewhlten Runde, dem jeweiligen Rep zugeteilt waren.
				$assignedcsvstores = $this->getAssignedCsvstores($acluserscsvstores, $utsRoundUntil);
			}
			$this->set("csvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores[0]['Csvstore']['id'], 1, $this->extractIDs($assignedcsvstores, "Csvstore"));
			$this->set(compact('selectedcsvstoreid'));	
				
			
			if (isset($this->params['form']['button'])) {
				// user hat formular ausgefllt und mchte daten speichern
				
				// ausgabe auf display immer schn formatieren
				// aber zuerst intern die eingabe parsen
				// @ falls leere eingabe
				$this->params["data"]["totalsum"] = @money_format("%i", $this->parseMoney($this->params["data"]["totalsum"] ));
				
				$order = $this->params["data"];
				$order["totalsum"] = $this->parseMoney($this->params["data"]["totalsum"]);
				
				$order["uts_orderdate"] = strtotime($order["orderdate"]);
				unset($order["orderdate"] );
				$order["uts_orderinserted"] = time();
				
				$order["ip"] = $_SERVER['REMOTE_ADDR'];
				$order["round_id"] = $selectedroundid;
				
				$order["manufacturer_id"] = $selectedmanufacturerid;
				
				$order["csvstore_id"] = $selectedcsvstoreid;
				
				if ($id>0) {
					// user will bestellung ndern, nicht hinzufgen
					$order["id"] = $id;
				} else {
					// user will bestetellung hinzufgen, nicht ndern
					$order["orderer_id"] = $this->getLoggedInUserID();
				}

				//print_r ($order);
				
				$this->Order->set( $order );
				if ($this->Order->validates()) {
					if ($this->Order->save($order)) {
						$this->redirect("/orders/addorchange/" . $id);
					} else {
						$this->flash("Datenbankfehler! Bitte probieren Sie es zu einem spteren Zeitpunkt erneut", "/orders/add");
					}
				} else {
					// could not validate data
					$errors = $this->Order->invalidFields();
					//print_r($errors);
					$this->set(compact("errors"));
				}
			} else {
				// user hat noch nichts eingegeben, default-vorbelegungen:
				$this->params["data"]["orderdate"] = date("d.m.Y");
			}
			
			if ($this->Closedround->isClosed($selectedroundid, $selectedmanufacturerid, $this->getLoggedInUserID())) {
				$this->set("roundclosed", "Runde bereits abgeschlossen");
			}
			
			
			$distributors = $this->Distributor->findAll("Distributor.isEnabled='y'");
			$this->set("distributors", $distributors);
			

			$orders = $this->paginate("Order", array("Order.isEnabled='y' and Order.round_id= " . $selectedroundid . " and Order.manufacturer_id=" . $selectedmanufacturerid . " and Order.csvstore_id=" . $selectedcsvstoreid ));
			$this->set(compact("orders"));
		}
	}
}
?>
