<?php
class ReportsController extends AppController{

	var $uses=array("Report", "Round", "Aclusersmanufacturer", "Acluserscsvstore", "Task", "Taskcheck", "Csvstore", "Order", "Csvproduct", "Stockcheck", "Payment", "Paymentcheck", "Closedround", "User", "Aclusersmanufacturer", "Csvproduct", "Acltaskscsvstore", "Deadline", "Rack");


	var $helpers = array('pdf'); // this will use the pdf.php class 
	
	var $paginate = array(
        'limit' => 100,
    );
	
	function taskpdfs() {
		if ($this->requireAccess(true, array("rep"))) {
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until asc "  );
			
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);

			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));

			$utsRoundUntil = $this->Round->getUtsRoundUntil($rounds, $selectedroundid);
				
			$aclusersmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID(). " order by name asc" );
			// In Array $assignedmanufacturers werden alle Hersteller gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
			$assignedmanufacturers =  $this->getAssignedManufacturers($aclusersmanufacturers, $utsRoundUntil);
			$this->set("assignedManufacturers", $assignedmanufacturers);
			
			/*
			//Uts_round_until der ausgewählten Runde wird rausgefiltert
			foreach ($rounds as $round) {
				
				if ($round["Round"]["id"] == $selectedroundid) {
					$utsRoundUntil = $round["Round"]["uts_round_until"];
					break;
				}
			}*/

			// diese stores betreut der rep
			$acluserscsvstores = $this->Acluserscsvstore->findAll("user_id=".$this->getLoggedInUserID(). " order by uniqueExtID");
			// In Array $assignedcsvstores werden alle Stores gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
			$assignedcsvstores = $this->getAssignedCsvstores($acluserscsvstores, $utsRoundUntil);
			$this->set("acluserscsvstores", $assignedcsvstores);
			


			// userstorids werden hier rausgefiltert um sie in der View mit den Aufgaben zu vergleichen
			$assignedcsvstoresIDs = array();
			foreach ($assignedcsvstores as $assignedcsvstore) {
				
				if ($assignedcsvstore["Assignedroundfrom"]["uts_round_until"] < $utsRoundUntil){
					array_push($assignedcsvstoresIDs, $assignedcsvstore["Acluserscsvstore"]["csvstore_id"]);
				}
			}
			$this->set("assignedcsvstoresIDs", $assignedcsvstoresIDs);

			
			// In Array $assignedcsvstores werden alle Stores gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
			/*$assignedmanufacturers = array();
			foreach ($aclusersmanufacturers as $aclusersmanufacturer) {
				
				if ($aclusersmanufacturer["Assignedroundfrom"]["uts_round_until"] < $utsRoundUntil){
					array_push($assignedmanufacturers, $aclusersmanufacturer);
				}
			}
			$this->set("assignedManufacturers", $assignedmanufacturers);
			*/

			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 1, $this->extractIDs($assignedmanufacturers, "Manufacturer"));
			$this->set(compact('selectedmanufacturerid'));
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores[0]['Csvstore']['id'], 0, $this->extractIDs($assignedcsvstores, "Csvstore"));
			$this->set(compact('selectedcsvstoreid'));
			
			
			
			//Aufträge
			$this->set("tasks", $this->Task->findAll("Task.isEnabled='y' and manufacturer_id=".$selectedmanufacturerid . " and round_id=".$selectedroundid));
			
			$whereClause = "";
			if ($selectedcsvstoreid > 0) {
				// nur einen ausgewählten markt anzeigen
				$whereClause = " AND csvstore_id= ".$selectedcsvstoreid;
			} else {
				$whereClause = "";
			}
			
			$this->set("acltaskscsvstores", $this->Acltaskscsvstore->findAll("Task.isEnabled='y' and Task.round_id= ".$selectedroundid." and Task.manufacturer_id= " .$selectedmanufacturerid . $whereClause));
			
			//query für alle acltaskscsvstores unabhängig von Marktauswahl
			$this->set("cleanAcltaskscsvstores", $this->Acltaskscsvstore->findAll());
			
			// herausfiltern ob Runde bereits vom Accounmanager abgesegnet
			$this->set("deadlines", $this->Deadline->findAll("Deadline.manufacturer_id=".$selectedmanufacturerid." and Deadline.round_id=".$selectedroundid));
		
		}

	}
	
	/* KILLME wird nicht mehr benötigt
	function offlinepdfs() {
		if ($this->requireAccess(true, array("rep"))) {
			$rounds = $this->Round->findAll("isEnabled='y' order by uts_round_until asc "  );
			
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);

			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));

			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));


			
			
			$aclusersmanufacturers = $this->paginate('Aclusersmanufacturer', array( "manufacturer_id=" . $selectedmanufacturerid . " and user_id=" . $this->getLoggedInUserID() ) );
			$this->set('aclusersmanufacturers', $aclusersmanufacturers);
			
			
			
			
			// diese stores betreuen die reps
			$acluserscsvstores = $this->Acluserscsvstore->findAll(" user_id=" . $this->getLoggedInUserID());
			$this->set("csvstores", $acluserscsvstores);
		}
			
	}
	*/
	
	function taskpdf() {
		if ($this->requireAccess(true, array("rep"))) {
			
			$rounds = $this->Round->findAll("isEnabled='y' order by uts_round_until asc "  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			
			//$round_id = (int)$unsafe_round_id;
			
			$this->layout = 'pdf'; //this will use the pdf.thtml layout
			
			$this->set("round", $this->Round->find("Round.id=".$selectedroundid));
			$this->set("rep", $this->User->find("User.id=".$this->getLoggedInUserID() ));
			
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			
			//$this->set("csvstores", $this->Acluserscsvstore->findAll("user_id=".$this->getLoggedInUserID() ));
			$this->set("manufacturers", $this->Aclusersmanufacturer->findAll("user_id=".$this->getLoggedInUserID()." and manufacturer_id=".$selectedmanufacturerid ));

			//$this->set("csvproducts", $this->Csvproduct->findAll("Csvproduct.isEnabled='y'" )); // todo: eol produkte abziehen
			
			//$this->set("payments", $this->Payment->findAll("" )); // todo: zeitraum berücksichtigen
			
			$this->set("tasks", $this->Task->findAll("Task.isEnabled='y' and round_id=".$selectedroundid )); // todo: zeitraum berücksichtigen, ggf zurodnung zum und zum store berücksichtigen -> tasks die einem user ned zugeordnet sind sollten nicht angezeigt werdenU
			
			
			// auf die märkte des eingeloggten users filtern
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() . " order by uniqueExtID" );
			$whereClause="";
			$whereClause .= "( 1=0 ";
			foreach ($assignedcsvstores as $assignedcsvstore) {
				$whereClause .= " or csvstore_id=".$assignedcsvstore["Csvstore"]["id"];
			}
			$whereClause .= ")";
			
			$this->set("acltaskscsvstores", $this->Acltaskscsvstore->findAll(" 1=0 OR " . $whereClause) );
	
			$this->render();
		}
	}
	function offlinepdf()  {
	
		if ($this->requireAccess(true, array("rep"))) {
			
			$rounds = $this->Round->findAll("isEnabled='y' order by uts_round_until asc "  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			$selectedround =$this->Round->find("Round.id=" . $selectedroundid);
			
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			//$round_id = (int)$unsafe_round_id;
			
			$this->layout = 'pdf'; //this will use the pdf.thtml layout
			$this->set('data','hello world!');
			
			$this->set("round", $this->Round->find("Round.id=".$selectedroundid));
			$this->set("rep", $this->User->find("User.id=".$this->getLoggedInUserID() ));
			
			
			$this->set("csvstores", $this->Acluserscsvstore->findAll("user_id=".$this->getLoggedInUserID() ));
			$this->set("manufacturers", $this->Aclusersmanufacturer->findAll("user_id=".$this->getLoggedInUserID()." and manufacturer_id=".$selectedmanufacturerid ));

			$this->set("csvproducts", $this->Csvproduct->findAll("Csvproduct.isEnabled='y' ORDER BY productCategory" ));
			
			// exakte zahlungen für diese kw
			// wird lt bani 20091001 nicht mehr benötigt, jetzt sollen neuerdings
			// alle zahlungen angezeigt werden, die im jahr 2009 (also im entsprechenden kalenderjahr)
			// enden
			/*
			$payments = $this->Payment->findAll("Payment.isEnabled='y' " . 
			" and Roundfrom.uts_round_until <=" .$selectedround["Round"]["uts_round_from"] .
			" and Rounduntil.uts_round_until >=" .$selectedround["Round"]["uts_round_until"] .
			" ORDER BY hasToBeCheckedByRep, payment_from_round_id, payment_until_round_id"
			);
			*/
			$year = date("Y",$selectedround["Round"]["uts_round_from"]);
			$payments = $this->Payment->findAll("Payment.isEnabled='y' " . 
			" and Roundfrom.uts_round_until >=" . mktime(0,0,0,1,1,$year) .
			" and Rounduntil.uts_round_until <=" . mktime(0,0,-1,1,1,$year+1) .
			" and manufacturer_id='".$selectedmanufacturerid ."' " . 
			" ORDER BY hasToBeCheckedByRep, payment_from_round_id, payment_until_round_id"
			);



			$this->set(compact("payments"));
			
			//$this->set("payments", $this->Payment->findAll("ORDER BY hasToBeCheckedByRep, payment_from_round_id, payment_until_round_id")); // todo: zeitraum berücksichtigen aktuelles Jahr
			$this->set("selectedroundid", $selectedroundid);
			$this->render();
		}
	}


	function deactivate($id)
	{
		// deaktivieren darf nur der am
		if ($this->requireAccess(true, array("accountmanager"))) {
			$report = $this->Report->read(null, $id);
			$report['Report']['isEnabled']="n";

			if ($this->Report->save($report))
			{
				$this->flash('Report (ID: '.$id.') wurde deaktiviert.', '/reports/show');
			} else {
				$this->flash('Report (ID: '.$id.') konnte nicht deaktiviert werden.', '/reports/show', 0);
			}
		}
	}
	function activate($id)
	{
		$report = $this->Report->read(null, $id);
		$report['Report']['isEnabled']="y";

		if ($this->Report->save($report))
		{
			$this->flash('Report (ID: '.$id.') wurde aktiviert.', '/reports/show');
		}
	}


	function detail($unsafe_id) {
		$id=(int)$unsafe_id;
		if ($this->requireAccess(true, array("accountmanager", "rep"))) {
			// user ist als am oder als rep eingelogged
			$report = $this->Report->find("Report.id=$id and Report.isEnabled='y'");
			
			$rack = $this->Rack->find("manufacturer_id=".$report["Report"]["manufacturer_id"]." AND isEnabled='y'");
			
			$minimumRackwidth = $rack["Rack"]["minimumRackwidth"];
			
			$rackRatio = ($report["Report"]["rackwidth"] / $report["Report"]["totalrackwidth"]) * 100; //
			
			if ($this->getLoggedInRoleID()==$this->getRoleIdByKey("rep") && $report["Report"]["user_id"] == $this->getLoggedInUserID()) {
				// user is als rep eingelogged und schaut sich seinen eigenen report an
			} else if ($this->getLoggedInRoleID()==$this->getRoleIdByKey("accountmanager")) {
				// user ist als am eingelogged und schaut sich einen fremden report an.
				// TODO: am kann nicht nur die reps seiner marke sondern auch die reports vom rep anderer marken einsehen
			} else {
				$this->flash('Benutzerrechte nicht ausreichend um einen Report eines anderen Reps zu betrachten.', '/reports/show');
				
			}
			$this->set("minimumRackwidth", $minimumRackwidth);
			$this->set("rackRatio", $rackRatio);
			$this->set(compact("report"));// user ist als am oder als rep (der seinen eigenen report sehn will) eingelogged
		}
	}


	// export show()-ansicht in csv-file
	function export() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			// csv macht nur ohne debug-info von cake sinn, andernfals ist das csv malformed
			Configure::write('debug', '0');
			// alle datensätze ausgeben, paging deaktivieren
			//$this->paginate['limit'] = 0;
			
			
			// weißes layout nehmen, damit kein html ins csv rutscht
			$this->layout = 'minimalistic';
			// alles exportieren, was show anzeigen würde
			$this->show();
		}
	}
	
	function exporthtml() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			/*
			$rounds = $this->Round->findAll("isEnabled='y'  and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().")"  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID(). " order by name asc" );
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 1, $this->extractIDs($assignedmanufacturers, "Manufacturer"));
			$this->set(compact('selectedmanufacturerid'));
			
			$reports = $this->paginate("Report", array(" Report.isEnabled='y' and round_id=".$selectedroundid . " and manufacturer_id=" . $selectedmanufacturerid));
			
			
			foreach ($reports as &$report) {
			
				//Funktion Show wird ergänzt und das Regalmeter-Verhältniss zum $reports Array hinzuzufügen (wird bei der Exportfunktion ausgegeben)
				$rack = $this->Rack->find("manufacturer_id=".$report["Report"]["manufacturer_id"]." AND isEnabled='y'");
				
				$minimumRackwidth = $rack["Rack"]["minimumRackwidth"];
				
				if ($report["Report"]["totalrackwidth"] > 0) {
					$rackRatio = ($report["Report"]["rackwidth"] / $report["Report"]["totalrackwidth"]) * 100;
				} else {
					$rackRatio = 0;
				}
				
				//$report["Report"]["rackRatio"] = $rackRatio;
			 
			}
			
			$this->set(compact("minimumRackwidth"));
			$this->set(compact("rackRatio"));
			$this->set(compact("reports"));
			*/
			// csv macht nur ohne debug-info von cake sinn, andernfals ist das csv malformed
			Configure::write('debug', '0');
			// alle datensätze ausgeben, paging deaktivieren
			//$this->paginate['limit'] = 0;
			
			
			// weißes layout nehmen, damit kein html ins csv rutscht
			$this->layout = 'minimalistic';
			// alles exportieren, was show anzeigen würde
			$this->show();
		}
	}

	function status() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			$rounds = $this->Round->findAll("isEnabled='y' order by uts_round_until asc ");
			
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			$this->set(compact('selectedroundid'));
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));

			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			$aclusersmanufacturers = $this->paginate('Aclusersmanufacturer', array("manufacturer_id=" .$selectedmanufacturerid. " AND User.role_id ='2' AND User.isEnabled ='y'"));
			$this->set('aclusersmanufacturers', $aclusersmanufacturers);
			
			
			// ********************* Geschlossene Runden **************
			$this->set("closedrounds", $this->Closedround->findAll("Closedround.round_id=".$selectedroundid . " and Closedround.manufacturer_id=".$selectedmanufacturerid));
			// ********************* Geschlossene Runden **************

			$this->set('current_round_id', $this->Round->getCurrentRoundID() );

			//$this->set("loggedInRoleID", $this->getLoggedInRoleID());
		}
	}
	
	
	
	function statusdetail($unsafe_userId) {
	
		if ($this->requireAccess(true, array("accountmanager"))) {
			
			$userId = mysql_real_escape_string($unsafe_userId);
			
			$rounds = $this->Round->findAll("isEnabled='y' order by uts_round_until asc "  );
			
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);

			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));

			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));


			$aclusersmanufacturers = $this->paginate('Aclusersmanufacturer', array( "manufacturer_id=" .$selectedmanufacturerid. " AND User.id =".$userId) );
			$this->set('aclusersmanufacturers', $aclusersmanufacturers);
			
		
			// diese stores betreuen die reps
			$acluserscsvstores = $this->Acluserscsvstore->findAll("User.id =".$userId);
			$this->set("acluserscsvstores", $acluserscsvstores);
			
			
			// Zu den Tasks zugehörigen Märkte
			$acltaskscsvstores = $this->Acltaskscsvstore->findAll();
			$this->set("acltaskscsvstores", $acltaskscsvstores);
			
			
			// ******************** REPORTING *******************
			// diese reports hat der rep schon für den hersteller eingegeben
			// todo isenabled in die abfrage einbaun
			$this->set("reports", $this->Report->findAll("manufacturer_id=".$selectedmanufacturerid . " and round_id=".$selectedroundid ." AND user_id=".$userId ));
			// ******************** REPORTING *******************

			// ******************** AUFTRÄGE *******************
			$this->set("tasks", $this->Task->findAll("Task.isEnabled='y' and manufacturer_id=".$selectedmanufacturerid . " and round_id=".$selectedroundid));
			
			
			// todo: optimierung: menge der taskchecks reduzieren indem man join auf tasks macht und dort
			// nur die tasks für die runde (und ggf hersteller) abfragt
			$this->set("taskchecks", $this->Taskcheck->findAll("Task.isEnabled='y' and  Task.round_id=".$selectedroundid . " and Task.manufacturer_id=".$selectedmanufacturerid." AND user_id=".$userId));
			// ******************** AUFTRÄGE *******************

			// ******************** BESTELLUNGEN *******************
			$this->set("orders", $this->Order->findAll("Order.isEnabled='y' and manufacturer_id=".$selectedmanufacturerid . " and round_id=".$selectedroundid." AND orderer_id=".$userId));
			
			//$this->set("nullorders", $this->Nullorder->findAll("manufacturer_id=".$selectedmanufacturerid ." and round_id=".$selectedroundid ));
			// ******************** BESTELLUNGEN *******************


			// ******************** BESTANDSLISTE *******************
			$this->set("csvproducts", $this->Csvproduct->findAll("shouldBeChecked='y' and manufacturer_id=".$selectedmanufacturerid ));
			
			
			$this->set("stockchecks", $this->Stockcheck->findAll("	round_id=" .$selectedroundid . " and Csvproduct.manufacturer_id=".  $selectedmanufacturerid." AND user_id=".$userId));
			// ******************** BESTANDSLISTE *******************
			
			
			// ******************** ZAHLUNGEN *******************
			// todo: zeitraum einfließen lassen
			$this->set("payments", $this->Payment->findAll("Payment.isEnabled='y' and  hasToBeCheckedByRep='y' and Payment.manufacturer_id=". $selectedmanufacturerid));


			$this->set("paymentchecks", $this->Paymentcheck->findAll("	round_id=" .$selectedroundid . " and Payment.hasToBeCheckedByRep='y' and Payment.manufacturer_id=". $selectedmanufacturerid ." AND user_id=".$userId));
			// ******************** ZAHLUNGEN *******************
			
			
			// ********************* Geschlossene Runden **************
			$this->set("closedrounds", $this->Closedround->findAll("Closedround.round_id=".$selectedroundid . " and Closedround.manufacturer_id=".$selectedmanufacturerid." AND user_id=".$userId));
			// ********************* Geschlossene Runden **************
			

			$this->set('current_round_id', $this->Round->getCurrentRoundID() );

			//$this->set("loggedInRoleID", $this->getLoggedInRoleID());
			//print_r($selectedmanufacturerid);
		}
	}

	function show() {
		if ($this->requireAccess(true, array("rep", "accountmanager"))) {

			$rounds = $this->Round->findAll("isEnabled='y'  and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().")"  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$utsRoundUntil = $this->Round->getUtsRoundUntil($rounds, $selectedroundid);
			
			if ($this->requireAccess(false, array("accountmanager"))) {
				// accountmanager sieht alle seine Hersteller egal ab wann er diesem zugeteilt wurde
				$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID(). " order by name asc" );
			} else {
				$aclusersmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID(). " order by name asc" );
				// In Array $assignedmanufacturers werden alle Hersteller gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
				$assignedmanufacturers =  $this->getAssignedManufacturers($aclusersmanufacturers, $utsRoundUntil);
			}
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 1, $this->extractIDs($assignedmanufacturers, "Manufacturer"));
			$this->set(compact('selectedmanufacturerid'));
			
			
			
			$this->set("loggedInRoleID", $this->getLoggedInRoleID());
			$this->set("amRoleID", $this->getRoleIdByKey("accountmanager"));
			
			$whereClause="";
			if ($this->getLoggedInRoleID() == $this->getRoleIdByKey("rep")) {
				// rep darf nur seine eignenen reports sehn
				$whereClause.=" and Report.user_id=" . $this->getLoggedInUserID() ;
			}
			$reports = $this->paginate("Report", array(" Report.isEnabled='y' and round_id=".$selectedroundid . " and manufacturer_id=" . $selectedmanufacturerid . $whereClause)); // Report.isEnabled='y' and
			
			//Funktion Show wird ergänzt und das Regalmeter-Verhältniss zum $reports Array hinzuzufügen (wird bei der Exportfunktion ausgegeben)
			foreach ($reports as &$report) {
			
				$rack = $this->Rack->find("manufacturer_id=".$report["Report"]["manufacturer_id"]." AND isEnabled='y'");
			
				$minimumRackwidth = $rack["Rack"]["minimumRackwidth"];
				
				if ($report["Report"]["totalrackwidth"] > 0) {
					$rackRatio = ($report["Report"]["rackwidth"] / $report["Report"]["totalrackwidth"]) * 100;
				} else {
					$rackRatio = 0;
				}
				
				$report["Report"]["rackRatio"] = $rackRatio;
			 
			}
			
			$this->set(compact("minimumRackwidth"));
			//print_r($reports);
			//$this->set(compact("rackRatio"));
			$this->set(compact("reports"));
		}
	}
	
	
	
	/*
	function test() {

		//$report["Report"]["ID"] = 0;	
		$report=array();
		
		$report['Report']['uts_inserted'] = time();
		$report['Report']['ip'] = $_SERVER['REMOTE_ADDR'];
		$report['Report']['uts_workingtime'] = 12;
		$report['Report']['round_id'] = 49;
		$report['Report']['csvstore_id'] = 57;
		$report['Report']['manufacturer_id'] = 1;
		//print_r($report);
		//print_r($this->params['data']);
		
		$this->Report->set($report);
		if ($this->Report->validates()) {
			//echo "validate";
		
		
			if ($this->Report->save($report)) {
				echo "report saved";
			} else {
				echo "could not save";
			}
		} else {
			$errors = $this->Report->invalidFields();
			echo "errors";
			print_r($errors);
		}
		echo "done";

		exit(0);				
	}
	*/
	
	function test() {
		print_r( $this->Report->getNumReports(45, 77, 60));
		exit(0);
	}
	
	// report neu eingeben (anlegen) oder bearbeiten, beides möglich!
	function change($unsafe_csvstore_id=NULL) {
		if ($this->requireAccess(true, array("rep", "accountmanager"))) {
			$csvstore_id=(int)$unsafe_csvstore_id;
			if ($csvstore_id>0) {
				// todo: defaultwert ändern
				$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', $csvstore_id, 0);
				// security todo: gehört dieser store auch diesem user?
				
				$this->redirect("/reports/change");
			}
			
	
			
			$this->set("loggedInRoleID", $this->getLoggedInRoleID());
			$this->set("amRoleID", $this->getRoleIdByKey("accountmanager"));


		
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until asc "  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]["Round"]["id"]);
			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$utsRoundUntil = $this->Round->getUtsRoundUntil($rounds, $selectedroundid);

			$aclusersmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
			// In Array $assignedmanufacturers werden alle Hersteller gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
			$assignedmanufacturers =  $this->getAssignedManufacturers($aclusersmanufacturers, $utsRoundUntil);
			$this->set("assignedManufacturers", $assignedmanufacturers);
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 1, $this->extractIDs($assignedmanufacturers, "Manufacturer"));
			$this->set(compact('selectedmanufacturerid'));



			$acluserscsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() . " order by uniqueExtID" );
			// In Array $assignedcsvstores werden alle Stores gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
			$assignedcsvstores = $this->getAssignedCsvstores($acluserscsvstores, $utsRoundUntil);
			$this->set("csvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores[0]['Csvstore']['id'], 1, $this->extractIDs($assignedcsvstores, "Csvstore"));
			$this->set(compact('selectedcsvstoreid'));

			//echo "csvstoreid:" . $selectedcsvstoreid . " form: " . $_REQUEST['selectedcsvstoreid'];
			
			// nötig um in der view festzustellen ob bereits ein report eingegeben wurde
			// and user_id=".$this->getLoggedInUserID().
			$report=$this->Report->find("Report.isEnabled='y' and round_id=".$selectedroundid." and manufacturer_id=".	$selectedmanufacturerid . " and csvstore_id=".$selectedcsvstoreid);
			$this->set(compact("report")); //
			
			//print_r($report);
			
			
			
			if (empty($report)) {
				// keinen report für die 3 parameter gefunden
				// ->>> neuer report!
				
				if ($this->getLoggedInRoleID() == $this->getRoleIDByKey("accountmanager")) {
					// accounty darf keinen neuen report eingeben, sondern nur bearbeiten
					// lt bani 20090907
					$this->flash("Benutzerrechte nicht ausreichend", "/reports/show", 10);
				}
			
			
			
			
			} else {
				// mind. ein report ist für die 3 parameter verfügbar
				// ->>> report bearbeiten
			}
			
			
			
			if ($this->getLoggedInRoleID() == $this->getRoleIDByKey("rep")) {
				
				
				
				// ******************* hat der user bereits die runde abgeschlossen? *******************
				if ($this->Closedround->isClosed($selectedroundid, $selectedmanufacturerid, $this->getLoggedInUserID())) {
					// runde bereits abgeschlossen
					
					// existiert mind. ein deaktivierter report schon im system und ist kein aktiver im system?
					// wenn ja hat der accountmanager schon einen report deaktiviert und der rep
					// darf ihn nachreichen
					if ($this->Report->getNumDeactivatedReports($selectedroundid, $selectedmanufacturerid, $selectedcsvstoreid)>=1 && $this->Report->getNumReports($selectedroundid, $selectedmanufacturerid, $selectedcsvstoreid)==0 ) {
						// ja, mind. ein deaktivierter report gefunden, rep darf nachtragen
					} else {
						// nein, kein deaktivierter report gefunden, rep darf im moment keinen report eingeben
						$this->set("roundclosed", "Runde bereits abgeschlossen");
					}
				} 
				// ******************* /hat der user bereits die runde abgeschlossen? *******************
			}
			
			if (isset($this->params['data'])) {
				// user will daten speichern
				//$report = $this->params['data'];
				
				if ($this->getLoggedInRoleID() == $this->getRoleIDByKey("rep")) {
					// nur der rep setzt das user-feld, der am darf reports bearbeiten aber
					// dabei nicht den autor des reports verändern
					$report['Report']['user_id'] = $this->getLoggedInUserID();
				}
				$report['Report']['uts_inserted'] = time();
				$report['Report']['ip'] = $_SERVER['REMOTE_ADDR'];
				$report['Report']['uts_workingtime'] = strtotime($this->params['data']["Report"]['workingtime']);
				$report['Report']['round_id'] = $selectedroundid;
				$report['Report']['csvstore_id'] = $selectedcsvstoreid;
				$report['Report']['manufacturer_id'] = $selectedmanufacturerid;
				
				$report['Report']['headofdepartment']	=  $this->params['data']["Report"]["headofdepartment"];
				$report['Report']['scheduling']			=  $this->params['data']["Report"]["scheduling"];
				$report['Report']['jubduration'] 		=  $this->params['data']["Report"]["jubduration"];
				$report['Report']['wrap_up']			=  $this->params['data']["Report"]["wrap_up"];
				$report['Report']['sonderjubduration'] 	=  $this->params['data']["Report"]["sonderjubduration"];
				$report['Report']['rackwidth'] 			=  str_replace(",",".", $this->params['data']["Report"]["rackwidth"]);
				$report['Report']['totalrackwidth'] 	=  str_replace(",",".", $this->params['data']["Report"]["totalrackwidth"]);
				;
				$report['Report']['journey_time'] 		=  $this->params['data']["Report"]["journey_time"];
				$report['Report']['nullorders'] 		=  $this->params['data']["Report"]["nullorders"];
				$report['Report']['report'] 			=  $this->params['data']["Report"]["report"];
				$report['Report']['task'] 				=  $this->params['data']["Report"]["task"];
				
				//print_r($this->params['data']);
				// Die  Regalmeterzahl des Kunden des Reps darf nicht größer sein als die Regalmeter aller Hersteller
				//Achtung habe Felder in der View noch nicht sticky gemacht!!!
				if ($report['Report']['rackwidth'] > $report['Report']['totalrackwidth']) {
					$this->Session->setFlash('<div class="error-message-new"><img src="/img/cross_icon_small.png" alt="Cross Icon" /> Die Regalmeteranzahl des Kunden darf nicht größer sein als die Gesamt-Regalmeteranzahl.</div>');
				}else {
				
					$this->validateReport($report);
				}
				//$this->redirect("/reports/show");
			} else {
			// warum ist hier ein else Zweig?
			}
		}
		
				
	}	
			
			
			
			
			
			/*
			
			if ($this->getLoggedInRoleID() == $this->getRoleIDByKey("accountmanager")
				&&
				! $report_id > 0
			) {
				// accounty darf keinen neuen report eingeben, sondern nur bearbeiten
				// lt bani 20090907
				$this->flash("Benutzerrechte nicht ausreichend", "/reports/show", 10);
				
			}
			
			
			
			if ($report_id>0) {
				// user will report bearbeiten
				$report = $this->Report->find("Report.id=".$report_id);
				$this->set(compact("report"));
	
				if ($this->getLoggedInRoleID() == $this->getRoleIDByKey("rep")) {
					// user ist ein rep. dieser darf die reports nur ändern wenn die runde nicht schon
					// abgesegnet wurde und wenn er der autor des reports ist.
					
					
					// ******************* ist der report von dem rep oder ändert er den report eines anderen?
					if ($report["Report"]["user_id"] != $this->getLoggedInUserID()) {
						$this->flash("Berechtigungsfehler, das ist kein Report von Ihnen", "/reports/show");
					}
					// ******************* /ist der report von dem rep oder ändert er den report eines anderen?
					
					
					
					// ******************* hat der user bereits die runde abgeschlossen? *******************
					$closedround = $this->Closedround->findAll("round_id=" . $report["Report"]["round_id"] . " and user_id=".$this->getLoggedInUserID() . " and " . " manufacturer_id=" . $report["Report"]["manufacturer_id"]);
					if (sizeof($closedround)>0) {
						// runde bereits abgeschlossen
						$this->flash("Berechtigungsfehler: Sie habend die Runde ". $report["Report"]["round_id"] . " zu Report ".  $report["Report"]["id"] . " bereits abgeschlossen.", "/reports/show");
					}
					// ******************* /hat der user bereits die runde abgeschlossen? *******************
					
					
					
				} 
	
				//$this->Session->write("Global.selectedcsvstoreid", $report["Report"]["csvstore_id"] );
			} else {
				// user will report hinzufügen
				
				// sticky, daten wieder zurückgeben, loop ...
				if (isset($this->params["data"])) {
					$this->set("report", $this->params["data"]);
				}
			}
			
			$rounds = $this->Round->findAll("isEnabled='y' order by uts_round_until asc "  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]["Round"]["id"]);
			$this->set(compact('selectedroundid'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			

			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() . " order by name asc" );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));

			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() . " order by uniqueExtID" );
			$this->set("csvstores", $assignedcsvstores);
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id']);
			$this->set(compact('selectedcsvstoreid'));

			//echo "csvstoreid:" . $selectedcsvstoreid . " form: " . $_REQUEST['selectedcsvstoreid'];
			
			// nötig um in der view festzustellen ob bereits ein report eingegeben wurde
			$reports=$this->Report->findAll("Report.isEnabled='y' and user_id=".$this->getLoggedInUserID()." and round_id=".$selectedroundid." and manufacturer_id=".	$selectedmanufacturerid . " and csvstore_id=".$selectedcsvstoreid);
			$this->set(compact("reports"));
			//print_r($reports);



			
			
			

			if (isset($this->params['data'])) {
				// user will daten speichern
				$report = $this->params['data'];
				if ($report_id>0) {
					// user will report bearbeiten -> update statement in datenbank
					$report['Report']['id'] =$report_id;
				} else {
					// user will report neu eingeben -> insert statement
					$report['Report']['user_id'] = $this->getLoggedInUserID();
					
					
				}
				$report['Report']['uts_inserted'] = time();
				$report['Report']['ip'] = $_SERVER['REMOTE_ADDR'];
				$report['Report']['uts_workingtime'] = strtotime($report['Report']['workingtime']);
				$report['Report']['round_id'] = $selectedroundid;
				$report['Report']['csvstore_id'] = $selectedcsvstoreid;
				$report['Report']['manufacturer_id'] = $selectedmanufacturerid;
//				print_r($report);
				//print_r($this->params['data']);
				
				
				$this->validateReport($report);
				
				

			} else {
				// user will das formular
				$report = $this->Report->findAll("round_id=".$selectedroundid." and csvstore_id=".$selectedcsvstoreid." and Report.manufacturer_id=".$selectedmanufacturerid);
				
				
				
				$this->Session->setFlash('<div class="error-message-new"><img src="/img/cross_icon_small.png" alt="Cross Icon" /> aaa</div>');
				
			}
		}
		
	
	}
	
	*/
	function validateReport($report) {
		$this->Report->set($report);
		
		// wird für die view benötigt
		$this->set(compact("report"));
		
		if ($this->Report->validates()) {
			
			if ($this->Report->save($report)) {
				
				$this->redirect("/reports/show");
			} else {
				$this->flash("Datenbankfehler, bitte wiederholen Sie Ihre Eingaben", "/reports/change", 10);
			}
		} else {
			//print_r($report);
			//echo "Invaldiate";
			$errors = $this->Report->invalidFields();

			$this->set(compact("errors"));
			
			$this->Session->setFlash('<div class="error-message-new"><img src="/img/cross_icon_small.png" alt="Cross Icon" /> Nicht alle erforderlichen Felder wurden ausgef&uuml;llt.</div>');
		}

	}
}
?>
