<?php

class StatisticsController extends AppController {

	var $name = 'Statistics';
	var $uses = array("User", "Config", "Aclusersmanufacturer", "Acluserscsvstore", "Order", "Chain", "Report", "Closedround", "Stockcheck", "Csvproduct", "Acltaskscsvstore");
	
	var $paginate =  array(
							'Acluserscsvstore' => array('limit' => 100) , 
							'Chain'=>array('limit'=>100)
	);
	
	
	public function availabilityperproduct() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			$selectedyear = (int) $this->smartSession('Global.selectedyear', @$_REQUEST['selectedyear'], date("Y"));
			$this->set(compact('selectedyear'));
			
			//Alle Märkte werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID(),null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id'],0);
			$this->set(compact('selectedcsvstoreid'));
			
			$this->set("generalComboboxYearStart", $this->Config->getConfigValue("generalComboboxYearStart"));
			
			$csvproducts = $this->Csvproduct->findAll("manufacturer_id=".$selectedmanufacturerid,null, "productID ");
			$this->set(compact("csvproducts"));
			$selectedcsvproductid = $this->smartSession('Global.selectedcsvproductid', @$_REQUEST['selectedcsvproductid'], $csvproducts[0]['Csvproduct']['id'],0);
			$this->set(compact('selectedcsvproductid'));
			
			
		}
	}

	// $this->getProductChart("retail_price", 2009, 20, 57);	
	// showColumn ... e.g. "stock", "retail_price"
	public function getProductChart($showColumn, $selectedyear, $csvproduct_id, $csvstore_id) {
		if ($this->requireAccess(true, array("accountmanager"))) {
			// diese funktion liefert ein bild zurück, d.h. content type is image/png o.ä. und somit
			// macht cake debug info keinen sinn!
			Configure::write('debug', '0');
				
			//$selectedyear = 2009;
			//$csvproduct_id = 20;
			//$csvstore_id=57;
			
			$utsYearFrom = mktime(0,0,0,1,1,$selectedyear); // 1.1.2009 00:00:00
			$utsYearUntil = mktime(0,0,-1,1,1,$selectedyear+1); // 31.12.2009 23:59:59
			$rounds = $this->Round->getRoundsBetween($utsYearFrom, $utsYearUntil);
			
			// todo: optimierung: runde einfließen lassen
			$stockchecks = $this->Stockcheck->findAll("csvproduct_id=".$csvproduct_id." and csvstore_id=".$csvstore_id . " order by Round.uts_round_until asc"); 
			
			$csvproduct = $this->Csvproduct->find("Csvproduct.id=".$csvproduct_id);
			
			include($_SERVER['DOCUMENT_ROOT'] . "/../files/pChart/pChart/pData.class");     
			include($_SERVER['DOCUMENT_ROOT'] . "/../files/pChart/pChart/pChart.class");     
			include($_SERVER['DOCUMENT_ROOT'] . "/../files/pChart/pChart/pCache.class");     
			$DataSet = new pData;   
			
			foreach ($stockchecks as $stockcheck) {
				$DataSet->AddPoint($stockcheck["Stockcheck"][$showColumn],"Serie1", "a");  
				$DataSet->AddPoint($stockcheck["Round"]["uts_round_until"],"Serie2", "a");  
			}
			
			$DataSet->SetSerieName($csvproduct["Csvproduct"]["productID"],"Serie1");  
			$DataSet->AddSerie("Serie1");  
			$DataSet->AddSerie("Serie2");  
			$DataSet->SetXAxisName("X Axis");  
			$DataSet->SetYAxisFormat("number");
			$DataSet->SetXAxisFormat("date");
	
			$DataSet->SetXAxisName("Kalenderwoche");
			if ($showColumn=="retail_price") {
				$DataSet->SetYAxisName("VK Preis");
				$DataSet->SetYAxisUnit(" EUR");
				$maxYValue=400; // EUR
			} else {
				$DataSet->SetYAxisName("Lagerstand");
				$DataSet->SetYAxisUnit(" Stk");
				$maxYValue=100; // Stk
			}
	
			// graph's absolute width and height, all mesures are smaller than this values
			$width = 1200;  
			$height = 400;
			
			$MyCache = new pCache($_SERVER['DOCUMENT_ROOT'] . "/../files/pChart/Cache");  
			if ($MyCache->IsInCache("Pic#1",$DataSet->GetData())) {
				$MyCache->GetFromCache("Pic#1",$DataSet->GetData());  
			} else {
				$Test = new pChart($width,$height);  
				$Test->setColorPalette(0,255,0,0); // linienfarbe
				$Test->setFontProperties($_SERVER['DOCUMENT_ROOT'] . "/../files/pChart/Fonts/tahoma.ttf",8);   
		
				$Test->drawGraphAreaGradient(255,255,255,-100);  
				$Test->setDateFormat("K\W W"); // e.g. KW 02
		
				// maxYValue, zB 20 für 20Stk Lagerstand
				// 52 .. 52 Kalenderwochen im Jahr, wir zeigen ja ein Jahr an und wollen 52 Unterteilungen in X Richtung
				// start: immer 1.1. des jahres, ende: immer 31.12. des jahres
				$Test->setFixedScale(0, $maxYValue, 10, $utsYearFrom , $utsYearUntil , 52); 
		
				// grauer, runder rahmen um den Graphen
				$Test->drawFilledRoundedRectangle(7,7,$width-7,$height-9,5,240,240,240);   
				$Test->drawRoundedRectangle(5,5,$width-5,$height-7,5,230,230,230);   
				
				$Test->setGraphArea(80,30,$width-30,$height-80);  
				
				// Beschriftung zeichnen
				$Test->drawXYScale($DataSet->GetData(),$DataSet->GetDataDescription(),"Serie1","Serie2",115,115,115,false,45);  
				
				// Hintergrundfarbe des Graphen
				$Test->drawGraphArea(255,255,255,FALSE);  
				//$Test->drawGraphAreaGradient(30,30,30,-50);  
				
				// Gitternetzlinien zeichen
				$Test->drawGrid(4,TRUE,0,0,0,0, false);  
				 
				// Graph zeichnen
				$Test->drawXYGraph($DataSet->GetData(),$DataSet->GetDataDescription(),"Serie1","Serie2",0);  
	
				// Titel des Graphen
				$Title = $csvproduct["Manufacturer"]["name"] . " " . $csvproduct["Csvproduct"]["productID"];  
				$Test->drawTextBox(0,0,$width,30,$Title,0,0,0,0,ALIGN_CENTER,false,0,0,0,0);  
				
				$MyCache->WriteToCache("Pic#1",$DataSet->GetData(),$Picture);  // graph cachen
	
				$Test->Stroke(); // ausgabe als image/png
			}
			exit(0);
		}
	}	

	function salestarget() {
		if ($this->requireAccess(true, array("rep"))) {
			$statisticsYearStart = $this->Config->getConfigValue("statisticsYearStart");
			$this->set(compact("statisticsYearStart"));
			
			$selectedyear = (int) $this->smartSession('Global.selectedyear', @$_REQUEST['selectedyear'], date("Y"));
			$this->set(compact('selectedyear'));
				
			$userID=$this->getLoggedInUserID();
			
			
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $userID . " order by name asc" );
			$this->set("assignedManufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers [0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
				
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $userID . " order by uniqueExtID" );
			$this->set("csvstores", $assignedcsvstores);
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id']);
			$this->set(compact('selectedcsvstoreid'));
				
			// todo: auf jahr filtern
			$this->set("orders", $this->Order->findAll());
		}
			
	}
	
	
	
	function salesvolumeperstore() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			
			//$time_start = microtime_float();
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			$selectedyear = (int) $this->smartSession('Global.selectedyear', @$_REQUEST['selectedyear'], date("Y"));
			$this->set(compact('selectedyear'));
			
			//Alle Märkte werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID(),null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id'],0);
			$this->set(compact('selectedcsvstoreid'));
			
			$this->set("generalComboboxYearStart", $this->Config->getConfigValue("generalComboboxYearStart"));
			
			//print_r($assignedcsvstores);
			
			$whereClause = "";
			if ($selectedcsvstoreid > 0) {
				// nur einen ausgewählten markt anzeigen
				$whereClause = " AND csvstore_id= ".$selectedcsvstoreid;
			} else {
				$whereClause = "";
			}
			$selectedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() .$whereClause,null,  "Csvstore.uniqueExtID asc" );
			
			// Alle Bestellungen für den ausgewählten Markt, Hersteller werden angezeigt
			//$orders = $this->Order->findAll("Order.isEnabled = 'y'". $whereClause ." AND manufacturer_id=".$selectedmanufacturerid);		
			
			
			//******************** Auswertung Umsatz pro Markt *********************
			// Es werden alle Bestellungen gewertet egal ob du Runde abgeschlossen wurde oder nicht. Dh. Das sich die auswertungen im Laufe einer Runde noch ändern können.
				
			$salesPerQuater = array(); // Summe der Bestellungen pro Quartal
			$totalSales =  array(); //Summe aller Bestellungen
			$sales = array(); // sales array werden alle extrahierten daten gespeichert
			$vertikalSales = array(); //vertikale Summe pro Monat über alle Märkte hinweg
			$vertikalTotalSales = 0; // vertikale Summe der Spalte Gesamtsumme pro Markt
			
			// alle Monate werden durchlaufen
			for($month=1; $month<13; $month++) {
				
				$utsFrom = mktime(0,0,0,$month,1,$selectedyear);	//Der erste Tag des Monats 
				$utsUntil = mktime(0,0,-1,$month+1,1,$selectedyear); //Der letzte Tag eines Monats z.B. 31.12.2009 23:59 (Der letzte Tag eines Monats (kann als Tag "0" des folgenden Monats ausgedrückt werden zb.Friday, February 29th 2008, 00:00:00)
				
				$monthName = date("F",$utsFrom); //date("F",$utsMonthFrom) --> Name des Monats des utsFrom wird so herausgefiltert
				
				$orders[$monthName] = $this->Order->query("
				SELECT SUM(Orders.totalsum) AS totalsum, Csvstore.id, Csvstore.uniqueExtID
				FROM orders AS Orders   
				LEFT JOIN csvstores AS Csvstore ON (Orders.csvstore_id = Csvstore.id)
				WHERE Orders.isEnabled = 'y' AND manufacturer_id=".$selectedmanufacturerid." AND uts_orderdate >= ". $utsFrom ."
				AND uts_orderdate <= ".$utsUntil. $whereClause."
				GROUP BY Csvstore.id
				");
				
				foreach($selectedcsvstores as $selectedcsvstore){
				
					$csvstore = $selectedcsvstore["Csvstore"]["uniqueExtID"];
					
					$sales[$csvstore][$monthName] = 0;

					if (!empty($orders[$monthName])) {
						
						// Hier wird jeder Monat pro Markt durchlaufen
						foreach($orders[$monthName] as $order) {
						
							if ($order["Csvstore"]["id"] == $selectedcsvstore["Acluserscsvstore"]["csvstore_id"]) {
								//Bestellsummen werden summiert
								$sales[$csvstore][$monthName] = $sales[$csvstore][$monthName] + $order[0]["totalsum"];
							}
						}
					} 
					$salesPerQuater[$csvstore] = @$salesPerQuater[$csvstore] + $sales[$csvstore][$monthName];
					
					//Vertikalen Summe pro Monat über alle Märkte hinweg wird gebildet
					$vertikalSales[$monthName] = @$vertikalSales[$monthName] + $sales[$csvstore][$monthName];
					
					//Wenn Ende eines Quartals pro Kette also $month/4 == 0 werden die Summierten Bestellungen in das $sales array schreiben
					//Ein Quartal hat 3 Monate
					if ($month%3 == 0) {
					
						$sales[$csvstore]["Q".($month/3)] = $salesPerQuater[$csvstore];
						$totalSales[$csvstore] = @$totalSales[$csvstore] + $salesPerQuater[$csvstore];
						
						//Für vertikale Gesamt-Summe
						$vertikalTotalSales = $vertikalTotalSales + $salesPerQuater[$csvstore];
						//Für vertikale Quartals-Summe
						$vertikalSales["Q".($month/3)] = @$vertikalSales["Q".($month/3)] + $salesPerQuater[$csvstore];
						
						$salesPerQuater[$csvstore] = 0;
					}
					
					$sales[$csvstore]["totalsales"] = @$totalSales[$csvstore];
				}

				$vertikalSales["totalsales"] = $vertikalTotalSales;
			}//month
					
			$this->set("sales", $sales);
			$this->set("vertikalSales", $vertikalSales);
			//print_r($vertikalSales);
			//$time_end = microtime_float();
			//$time = $time_end - $time_start;
			//echo "Did nothing in $time seconds\n";
		}
	}
	
	
	
	function salesvolumeperchain() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			$selectedyear = (int) $this->smartSession('Global.selectedyear', @$_REQUEST['selectedyear'], date("Y"));
			$this->set(compact('selectedyear'));
			
			$chains = $this->paginate("Chain", array("Chain.isEnabled = 'y'"));
			//alt: $chains =  $this->Chain->findAll("ORDER BY Chain.name asc" );
			
			$this->set("generalComboboxYearStart", $this->Config->getConfigValue("generalComboboxYearStart"));
			
			// Alle Bestellungen für den ausgewählten Hersteller werden angezeigt
			//$orders = $this->Order->findAll("Order.isEnabled = 'y' AND manufacturer_id=".$selectedmanufacturerid);
			
			/*TEST
			$userId = $this->getLoggedInUserID();
			//$round = $this->Acluserscsvstore->find("user_id=".$userId);
			$rounds_assigned_csvstores = $this->Acluserscsvstore->query("
			SELECT user_id, rounds.id, MIN(uts_round_until) AS uts_round_until
			FROM acluserscsvstores, rounds 
			WHERE acluserscsvstores.round_id_from = rounds.id AND user_id=".$userId);
			
			$uts_round_until = $rounds_assigned_csvstores[0][0]["uts_round_until"];
			//$round = $this->Round->find("id=5");
			
			$smallest_round = $this->Acluserscsvstore->query("
			SELECT Round.id, user_id, Round.isEnabled, Round.uts_round_until, Round.description, Round.uts_round_inserted, MIN(uts_round_until) AS uts_round_until, Closedround.round_id AS ClosedRoundId
			FROM rounds AS Round
			LEFT JOIN (
				SELECT * 
				FROM closedrounds 
				WHERE user_id = ".$userId.") AS Closedround ON (Closedround.round_id = Round.id
			)
			WHERE uts_round_until > ".$uts_round_until." AND Closedround.round_id IS NULL");
			
			$round = $this->Round->find("id=5");
			
			print_r($round);
			print_r($smallest_round);
			TEST*/
			
			//******************** Auswertung Umsatz pro Kette *********************
			// Es werden alle Bestellungen gewertet egal ob du Runde abgeschlossen wurde oder nicht. Dh. Das sich die auswertungen im Laufe einer Runde noch ändern können.
			$salesPerQuater = array(); // Summe der Bestellungen pro Quartal
			$totalSales =  array(); //Summe aller Bestellungen
			$sales = array(); // sales array werden alle extrahierten daten gespeichert
			
			// alle Monate werden durchlaufen
			for($month=1; $month<13; $month++) {
				
				$utsFrom = mktime(0,0,0,$month,1,$selectedyear);	//Der erste Tag des Monats
				$utsUntil = mktime(0,0,-1,$month+1,1,$selectedyear); ////Der letzte Tag eines Monats z.B. 31.12.2009 23:59 
				
				$monthName = date("F",$utsFrom); //date("F",$utsMonthFrom) --> Name des Monats des utsFrom wird so herausgefiltert
				
				$orders[$monthName] = $this->Order->query("
				SELECT SUM(Orders.totalsum) AS totalsum, Csvstore.id, Csvstore.uniqueExtID, Chain.id
				FROM orders AS Orders   
				LEFT JOIN csvstores AS Csvstore ON (Orders.csvstore_id = Csvstore.id)
				LEFT JOIN chains AS Chain ON (Chain.id = Csvstore.chain_id) 
				WHERE Orders.isEnabled = 'y' AND manufacturer_id=".$selectedmanufacturerid." AND uts_orderdate >= ". $utsFrom ."
				AND uts_orderdate <= ".$utsUntil."
				GROUP BY Csvstore.chain_id
				");
				
				foreach($chains as $chain){
					
					$chainName = $chain["Chain"]["name"];
					
					$sales[$chainName][$monthName] = 0;

					if (!empty($orders[$monthName])) {
						
						// Hier wird jeder Monat pro Kette durchlaufen
						foreach($orders[$monthName] as $order) {
						
							if ($order["Chain"]["id"] == $chain["Chain"]["id"]) {
								//Bestellsummen werden summiert
								$sales[$chainName][$monthName] = $sales[$chainName][$monthName] + $order[0]["totalsum"];
							}
						}
					}
					$salesPerQuater[$chainName] = @$salesPerQuater[$chainName] + $sales[$chainName][$monthName];
				
					//Wenn Ende eines Quartals pro Kette also $month/4 == 0 werden die Summierten Bestellungen in das $sales array schreiben
					//Ein Quartal hat 3 Monate
					if ($month%3 == 0) {
					
						$sales[$chainName]["Q".($month/3)] = $salesPerQuater[$chainName];
						$totalSales[$chainName] = @$totalSales[$chainName] + $salesPerQuater[$chainName];
						$salesPerQuater[$chainName] = 0;
					}
					$sales[$chainName]["totalsales"] = @$totalSales[$chainName];
				}
			}
			$this->set("sales", $sales);
			//print_r($orders);
		}
	}
	
	
	
	function salesvolumesearch() {
		if ($this->requireAccess(true, array("accountmanager"))) {
		
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			//Alle Märkte werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID(),null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id'],0);
			$this->set(compact('selectedcsvstoreid'));
			
			$formErrors = array(); // mit diesem hilfsarray werden die fehlerausgaben an die view übergeben
			$formErrors['dateFrom'] = "";
			$formErrors['dateUntil'] = "";
			
			$sales = array(); // sales array werden alle extrahierten daten gespeichert
			
			$whereClause = "";

			if ($selectedcsvstoreid > 0) {
				// nur einen ausgewählten markt anzeigen
				$whereClause = " AND csvstore_id= ".$selectedcsvstoreid;
			} else {
				// Combobox alle Märkte anzeigen
				$whereClause = "";
			}
			//alt $selectedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() .$whereClause,null,  "Csvstore.uniqueExtID asc" );
			//Muss ich über cake, wegen paginaten, machen
			$selectedcsvstores = $this->paginate("Acluserscsvstore", array("user_id=" . $this->getLoggedInUserID() .$whereClause));
			
			if(isset($_REQUEST['submit']) || (isset($_SESSION['salesvolumesearch']['dateFrom']) && isset($_SESSION['salesvolumesearch']['dateUntil']))){
				
				if(isset($_REQUEST['submit'])) {
					//Datumseingaben werden validiert
					$utsDateFrom = AppController::validateDateInput($_REQUEST['data']['dateFrom']);
					$utsDateUntil = AppController::validateDateInput($_REQUEST['data']['dateUntil']);
					
					//utsFrom und utsUntil werden in die Session geschrieben wenn der absende Button geklickt wurde
					//Das brauchen wir da beim Paginaten die Seite reloaded wird und sonst auf die Datumseingaben nicht mehr zugegriffen werden könnte
					$utsDate['dateFrom'] = $utsDateFrom;
					$utsDate['dateUntil'] = $utsDateUntil;
					$this->Session->write("salesvolumesearch", $utsDate);
				}
				
				// Falls die Datumseingaben in die Session geschrieben wurde und das Formular nicht abgesendet wurde werden die Datumseingaben aus der Session ausgelesen
				// alt: ohne !isset($_REQUEST['submit'])
				if (!isset($_REQUEST['submit']) && isset($_SESSION['salesvolumesearch']['dateFrom']) && isset($_SESSION['salesvolumesearch']['dateUntil']) ) {

					$utsDateFrom = $this->Session->read("salesvolumesearch.dateFrom");
					$utsDateUntil = $this->Session->read("salesvolumesearch.dateUntil");
				}
				
				if ($utsDateFrom > 0 && $utsDateUntil > 0) {
					
					// 86399 --> 1 Tag in Sekunden (-1), da es ja der ganze tag gelten soll dh. (00:00:00 - 23:59:59)
					$utsDateUntil = $utsDateUntil + 86399;
					
					//Für Sticky
					$this->set("dateFrom", date("d.m.Y", $utsDateFrom));
					$this->set("dateUntil", date("d.m.Y", $utsDateUntil));
					
					
					//****************** Auswertung Umsatzsuche ************************
					// Summe aller Bestellungen für den ausgewählten Markt, Hersteller werden angezeigt
					
					// Summe der Bestellungen übber alle Stores hinweg
					$orders = $this->Order->query("
					SELECT Orders.id, Orders.csvstore_id, SUM(Orders.totalsum) AS totalsum, Csvstore.uniqueExtID
					FROM csvstores AS Csvstore
					LEFT JOIN orders AS Orders ON (Csvstore.id = Orders.csvstore_id) 
					WHERE Orders.isEnabled = 'y' AND manufacturer_id=".$selectedmanufacturerid. $whereClause." AND uts_orderdate >= ". $utsDateFrom ."
					AND uts_orderdate <= ".$utsDateUntil."
					GROUP BY Orders.csvstore_id
					");
					// Es werden alle Bestellungen gewertet egal ob du Runde abgeschlossen wurde oder nicht. Dh. Das sich die auswertungen im Laufe einer Runde noch ändern können.
					foreach($selectedcsvstores as $selectedcsvstore){
						
						$csvstore = $selectedcsvstore["Csvstore"]["uniqueExtID"];
						
						$sales[$csvstore] = $selectedcsvstore["Csvstore"];
						
						$storeFound = 0;
						
						foreach($orders as $order) {
						
							if ($order["Orders"]["csvstore_id"] == $selectedcsvstore["Csvstore"]["id"]) {
								
								$sales[$csvstore]["totalsum"] = $order[0]["totalsum"];
								$storeFound = 1;
								break;
							}
						}
							
						if (!$storeFound) {
							$sales[$csvstore]["totalsum"] = 0;
						}
					}
					
				} else {
	
					// eines der beiden datums-felder wurde nicht richtig eingegeben
					if ($utsDateFrom == false) {
						// fehler bei von-datum: datum falsch eingegeben
						$formErrors["dateFrom"] = "Fehler bei Eingabe (tt.mm.jjjj) ";
					}
					if ($utsDateUntil == false) {
						// fehler bei von-datum: datum falsch eingegeben
						$formErrors["dateUntil"] = "Fehler bei Eingabe (tt.mm.jjjj) ";
					}
				}
			}
			$this->set("sales", $sales);
			$this->set("formErrors", $formErrors);
		}
	}
	
	
	
	function salesvolumerepsearch() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			//Alle Märkte werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID(),null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id'],0);
			$this->set(compact('selectedcsvstoreid'));
			
			//Alle User werden herausgefiltert die SalesReps sind
			$salesreps =  $this->Aclusersmanufacturer->findAll("User.role_id =2 GROUP BY User.id ORDER BY User.last_name");

			$assignedsalesreps = array();
			
			foreach($salesreps as $salesrep){
				
				$repIsAssignedToManufacturer = 0;
				foreach($assignedmanufacturers as $assignedmanufacturer){
				
					if ($salesrep["Aclusersmanufacturer"]["manufacturer_id"] == $assignedmanufacturer["Aclusersmanufacturer"]["manufacturer_id"]) {
						$repIsAssignedToManufacturer = 1;
						break;
					}
				}
				if ($repIsAssignedToManufacturer) {
					array_push($assignedsalesreps, $salesrep);
				}	
			}
			$this->set("assignedsalesreps", $assignedsalesreps);
			
			$selectedrepid = @$_REQUEST['selectedrepid'];
			$this->set(compact('selectedrepid'));
			
			$whereClause = "";
			if ($selectedrepid > 0) {
				// nur einen ausgewählten markt anzeigen
				$whereClause = " AND User.id= ".$selectedrepid;
			} else {
				$whereClause = "";
			}
			
			$selectedreps =  $this->User->findAll("User.role_id = 2". $whereClause,null,  "User.last_name asc" );
			//print_r($selectedreps);
			
			$sales = array(); //im sales array werden alle extrahierten Daten gespeichert
			$sumOfSales = 0; //Summe aller Bestellungen die die Reps eingegeben haben
			
			$formErrors = array(); // mit diesem hilfsarray werden die fehlerausgaben an die view übergeben
			$formErrors['dateFrom'] = "";
			$formErrors['dateUntil'] = "";
			
			if(isset($_REQUEST['submit'])) {
				
				//Datumseingaben werden validiert
				$utsDateFrom = AppController::validateDateInput($_REQUEST['data']['dateFrom']);
				$utsDateUntil = AppController::validateDateInput($_REQUEST['data']['dateUntil']);
				
				if ($utsDateFrom > 0 && $utsDateUntil > 0) {
					
					// 86399 --> 1 Tag in Sekunden (-1), da es ja der ganze tag gelten soll dh. (00:00:00 - 23:59:59)
					$utsDateUntil = $utsDateUntil + 86399;
					
					//Für Sticky
					$this->set("dateFrom", date("d.m.Y", $utsDateFrom));
					$this->set("dateUntil", date("d.m.Y", $utsDateUntil));
					
					//****************** Auswertung Umsatzsuche SalesRep ************************
					// Alle Bestellungen für den ausgewählten SalesRep werden gefiltert, allerdings dürfen nur die Hersteller gezeigt werden die der Accountmanager
					// sehen darf
					$manufacturers_ids = $this->Aclusersmanufacturer->getManufacturerIDsForUser($assignedmanufacturers);
					$users_ids = $this->User->getUserIDs($selectedreps);
					/*
					$sales = $this->Order->query("
					SELECT SUM(Orders.totalsum) AS totalsum, Orders.orderer_id, Manufacturer.name
					FROM manufacturers AS Manufacturer
					LEFT JOIN orders AS Orders ON (Manufacturer.id = Orders.manufacturer_id)
					WHERE (Orders.orderer_id=".$selectedrepid." OR Orders.orderer_id IS NULL) AND (Manufacturer.id =".implode(" OR Manufacturer.id =", $manufacturers_ids).")
					 AND uts_orderdate >= ". $utsDateFrom ." AND uts_orderdate <= ".$utsDateUntil."
					GROUP BY Orders.manufacturer_id
					");
					*/
					
					$sales = $this->Order->query("
					SELECT SUM(Orders.totalsum) AS totalsum, Orders.orderer_id, Manufacturer.name, Users.last_name, Users.first_name
					FROM users AS Users 
					LEFT JOIN orders AS Orders ON (Orders.orderer_id = Users.id)
					LEFT JOIN manufacturers AS Manufacturer ON (Manufacturer.id = Orders.manufacturer_id)
					WHERE uts_orderdate >= ". $utsDateFrom ." AND uts_orderdate <= ".$utsDateUntil." 
					AND Orders.manufacturer_id =". $selectedmanufacturerid . " 
					AND Users.role_id = 2 AND Orders.isEnabled = 'y'
					AND (Orders.orderer_id =".implode(" OR Orders.orderer_id =", $users_ids).") OR Orders.orderer_id IS NULL
					GROUP BY Users.id
					ORDER BY Users.last_name ASC
					");
					
					//Wenn für den Hersteller noch nichts bestellt wurde ist $sale[0]["totalsum"] = NULL
					foreach ($sales as &$sale) {
						if (empty($sale[0]["totalsum"])) {
							$sale[0]["totalsum"] = 0;
						} else {
							$sumOfSales = $sumOfSales + $sale[0]["totalsum"];
						}
					}
					
					/*
					$orders = $this->Order->findAll("Order.isEnabled = 'y' AND Order.orderer_id =".$selectedrepid);
					
					foreach($assignedmanufacturers as $assignedmanufacturer){
					
						$manufacturerName = $assignedmanufacturer["Manufacturer"]["name"];
						
						$sales[$manufacturerName]["totalsum"] = 0;
						
						foreach($orders as $order){
							
							if ($assignedmanufacturer["Aclusersmanufacturer"]["manufacturer_id"] == $order["Order"]["manufacturer_id"] && $order["Order"]["uts_orderdate"] >= $utsDateFrom && $order["Order"]["uts_orderdate"] <= $utsDateUntil) {
							
								$sales[$manufacturerName]["totalsum"] = $sales[$manufacturerName]["totalsum"] + $order["Order"]["totalsum"];
							}
						} 	
					}
					*/
					
				} else {
	
					// eines der beiden datums-felder wurde nicht richtig eingegeben
					if ($utsDateFrom == false) {
						// fehler bei von-datum: datum falsch eingegeben
						$formErrors["dateFrom"] = "Fehler bei Eingabe (tt.mm.jjjj) ";
					}
					if ($utsDateUntil == false) {
						// fehler bei von-datum: datum falsch eingegeben
						$formErrors["dateUntil"] = "Fehler bei Eingabe (tt.mm.jjjj) ";
					}
				}
				//print_r($sales);
			}
			$this->set("sales", $sales);
			$this->set("formErrors", $formErrors);
			$this->set("sumOfSales", $sumOfSales);
			//print_r($sales);	
		}	
	}
	
	
	function workingtimepermarket() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			//Alle Märkte werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID(),null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id'],0);
			$this->set(compact('selectedcsvstoreid'));
			
			//Alle Runden werden berücksichtig bis(inklusive) zur aktuellen KW
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until desc "  );
			$this->set(compact('rounds'));
			//$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			
			$this->set(compact('selectedroundid'));
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));		
			
			
			$whereClause = "";
			if ($selectedcsvstoreid > 0) {
				// nur einen ausgewählten markt anzeigen
				$whereClause = " AND csvstore_id= ".$selectedcsvstoreid;
			} else {
				// Combobox alle Märkte anzeigen
				$whereClause = "";
			}
			
			$statistics = array(); //im statistics array werden alle extrahierten Daten gespeichert
			$totalDuration = array();
			
			if(isset($_REQUEST['submit'])) {
				
				$selectedroundfromid = @$_REQUEST['selectedroundfromid'];
				$this->set(compact('selectedroundfromid')); //für Sticky
				$selectedrounduntilid = @$_REQUEST['selectedrounduntilid'];
				$this->set(compact('selectedrounduntilid')); //für Sticky
				
				foreach($rounds as $round) {
					//Uts_round_from der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedroundfromid) {
						$utsRoundFrom = $round["Round"]["uts_round_from"];
					}
					//Uts_round_until der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedrounduntilid) {
						$utsRoundUntil = $round["Round"]["uts_round_until"];
					}
				}
				
				//****************** Auswertung Umsatzsuche SalesRep ************************
				$selectedcsvstores = $this->Acluserscsvstore->query("
				SELECT Csvstore.id, Csvstore.uniqueExtID, Csvstore.storeName, Csvstore.zipcode, Csvstore.city, Csvstore.address
				FROM acluserscsvstores AS Acluserscsvstore 
				LEFT JOIN csvstores AS Csvstore ON (Acluserscsvstore.csvstore_id = Csvstore.id)  
				WHERE user_id=". $this->getLoggedInUserID() .$whereClause ." 
				ORDER BY Csvstore.uniqueExtID asc
				");
				
				// $reports sind die Statistiken pro Csvstore
				$reports = $this->Report->query("
				SELECT SUM(Report.jubduration) AS jobduration, SUM(Report.sonderjubduration) AS sonderjubduration, Csvstore.uniqueExtID, Csvstore.storeName, 
				Csvstore.zipcode, Csvstore.city, Csvstore.address, Csvstore.id
				FROM reports AS Report
				LEFT JOIN csvstores AS Csvstore ON (Report.csvstore_id = Csvstore.id) 
				WHERE Report.isEnabled= 'y' AND Report.manufacturer_id=". $selectedmanufacturerid  ." AND uts_workingtime >= ". $utsRoundFrom ."
				AND uts_workingtime <= ". $utsRoundUntil.$whereClause."
				GROUP BY Report.csvstore_id
				ORDER BY Csvstore.uniqueExtID asc
				");
				
				$totalDuration["totaljobduration"] = 0;
				$totalDuration["totalextrajobduration"] = 0;
				
				foreach($selectedcsvstores as $selectedcsvstore) {
					
					$storeFound = 0;
					$storeName = $selectedcsvstore["Csvstore"]["uniqueExtID"];
					$statistics[$storeName] = $selectedcsvstore["Csvstore"];
					
					foreach($reports as $report) {
						
						if ($report["Csvstore"]["id"] == $selectedcsvstore["Csvstore"]["id"]) {
							
							$statistics[$storeName]["jobduration"] = $report[0]['jobduration'];
							$statistics[$storeName]["extrajobduration"] = $report[0]['sonderjubduration'];
							$storeFound = 1;
							break;
						}
					}
					
					if (!$storeFound) {

						$statistics[$storeName]["jobduration"] = 0;
						$statistics[$storeName]["extrajobduration"] = 0;
					}
					$totalDuration["totaljobduration"] = $totalDuration["totaljobduration"] + $statistics[$storeName]["jobduration"];
					$totalDuration["totalextrajobduration"] = $totalDuration["totalextrajobduration"] + $statistics[$storeName]["extrajobduration"];
				}
				//print_r($totalDuration);
			}
			$this->set(compact('statistics'));
			$this->set(compact('totalDuration'));
		}
	}
	
	
	
	function reliabilityperrep() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			//Alle Runden werden berücksichtig bis(inklusive) zur aktuellen KW
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until desc "  );
			$this->set(compact('rounds'));
			//$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			
			$this->set(compact('selectedroundid'));
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$statistics = array(); //im statistics array werden alle extrahierten Daten gespeichert
			
			//print_r($_REQUEST);
			
			if(isset($_REQUEST['submit'])) {
				
				$selectedroundfromid = @$_REQUEST['selectedroundfromid'];
				$this->set(compact('selectedroundfromid')); //für Sticky
				$selectedrounduntilid = @$_REQUEST['selectedrounduntilid'];
				$this->set(compact('selectedrounduntilid')); //für Sticky
				
				foreach($rounds as $round) {
					//Uts_round_from der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedroundfromid) {
						$utsRoundFrom = $round["Round"]["uts_round_from"];
					}
					//Uts_round_until der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedrounduntilid) {
						$utsRoundUntil = $round["Round"]["uts_round_until"];
					}
				}
				
				//****************** Auswertung Umsatzsuche SalesRep ************************
				$reports = $this->Report->query("
				SELECT Report.user_id, COUNT(Report.id) AS promotionsCnt, SUM(Report.jubduration) AS totalWorkingtime
				FROM reports AS Report  
				WHERE Report.isEnabled='y' AND Report.manufacturer_id=".$selectedmanufacturerid." 
				AND uts_workingtime >=".$utsRoundFrom." AND uts_workingtime <= ".$utsRoundUntil."
				GROUP BY Report.user_id
				");
				
				$rounds = $this->Round->getRoundsBetween($utsRoundFrom, $utsRoundUntil);
				$round_ids = $this->Round->getRoundIDsForRounds($rounds);
				
				//$closedRounds = $this->Closedround->findAll("manufacturer_id=".$selectedmanufacturerid);
				$closedRounds = $this->Closedround->findAll("(round_id=".implode(" or round_id=", $round_ids).") AND manufacturer_id=".$selectedmanufacturerid);
				
				//Reps die dem ausgewählten Hersteller zugeteilt sind werden herausgefiltert
				$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("manufacturer_id =".$selectedmanufacturerid. " AND User.role_id=2 ORDER BY User.last_name");
				
				foreach($assignedmanufacturers as $assignedmanufacturer) {
					
					$repName = $assignedmanufacturer["User"]["username"];
					$statistics[$repName] = $assignedmanufacturer["User"];
					
					
					//------------ pünktlich und unpünktlich abgeschlossene Runden sowie zuverlässigkeit werden eruiert -----------------------
					$unpunctual = 0; //unpünktlich abgeschlossene Runden
					$onTime = 0; //pünktlich abgeschlossene Runden
					$reliability = 0; // zuverlässigkeit des Reps --> wieviele Runden, von seinen abgeschlossenen, hat der Rep pünktlich abgeschlossen in %
					
							
					foreach($closedRounds as $closedRound) {
						
						//$closedRound["Closedround"]["round_id"] == $round["Round"]["id"] && 
						if ($closedRound["Closedround"]["user_id"] == $assignedmanufacturer["Aclusersmanufacturer"]["user_id"]) { 
							
							if ($closedRound["Closedround"]["uts_closed"] > $closedRound["Round"]["uts_round_until"]) {
								$unpunctual++;
							}
							if ($closedRound["Closedround"]["uts_closed"] <= $closedRound["Round"]["uts_round_until"]) {
								$onTime++;
							}
						}
					}
					if (($onTime + $unpunctual) > 0) { //um division by zero zu vermeiden
						$reliability = ($onTime / ($onTime + $unpunctual)) * 100; 	
					}

					$statistics[$repName]["unpunctual"] = $unpunctual;
					$statistics[$repName]["onTime"] = $onTime;
					$statistics[$repName]["reliability"] = $reliability;
					
					
					//------ Durchschnittliche Marktzeit ------
					$totalWorkingtime = 0; //Summe der Arbeitszeit pro Rep
					$averageWorkingtime = 0; // durchschnittliche Arbeitszeit pro Rep
					
					
					foreach($reports as $report) {
					
						if ($report["Report"]["user_id"] == $assignedmanufacturer["Aclusersmanufacturer"]["user_id"] && $report[0]["promotionsCnt"] > 0) {
							
							$averageWorkingtime = $report[0]["totalWorkingtime"] / $report[0]["promotionsCnt"];
							break;
						}
					}
					$statistics[$repName]["averageWorkingtime"] = $averageWorkingtime;
				}
				//print_r($reports);
			}
			$this->set(compact('statistics'));	
		}
	}
	
	
	
	function rankingperrep() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			$selectedyear = (int) $this->smartSession('Global.selectedyear', @$_REQUEST['selectedyear'], date("Y"));
			$this->set(compact('selectedyear'));
			
			$this->set("generalComboboxYearStart", $this->Config->getConfigValue("generalComboboxYearStart"));
			
			$utsYearFrom = mktime(0,0,0,1,1,$selectedyear); // 1.1.2009 00:00:00
			$utsYearUntil = mktime(0,0,-1,1,1,$selectedyear+1); // 31.12.2009 23:59:59

			//print_r($_REQUEST);

			$statistics = array(); //im statistics array werden alle extrahierten Daten gespeichert
			
			$rounds = $this->Round->getRoundsBetween($utsYearFrom, $utsYearUntil);
			$round_ids = $this->Round->getRoundIDsForRounds($rounds);
			
			$closedrounds = $this->Closedround->findAll("(round_id=".implode(" or round_id=", $round_ids).") AND manufacturer_id=".$selectedmanufacturerid);
			
			//$tasks = $this->Acltaskscsvstore->findAll("(round_id=".implode(" or round_id=", $round_ids).") AND manufacturer_id=".$selectedmanufacturerid." AND Task.isEnabled='y'");

			$csvproducts =  $this->Csvproduct->findAll("manufacturer_id =".$selectedmanufacturerid." AND productCategory='A'");
			
			//$assignedcsvstores =  $this->Acluserscsvstore->findAll();
			
			// In dieser Query werden die Märkte für alle Reps pro geschlossener Runde, die mindestens einen Auftrag oder dem Rep in der aktuellen geschlossenen
			// Runde, ausgewertet.
			
			/* ALT 12.04.2010
			$assignedcsvstores = $this->Acluserscsvstore->query("
			SELECT COUNT(Assignedstores.csvstore_id) AS repstores, Closedround.user_id AS closedround_user_id, Assignedstores.user_id, Assignedstores.csvstore_id, 
			Assignedstores.uts_round_until AS uts_assignedstoresroundfrom, Closedroundfrom.uts_round_until AS uts_closedround_until, Closedround.round_id AS Closedround_id, 
			Assignedstores.round_id
			FROM closedrounds AS Closedround
			LEFT JOIN rounds AS Closedroundfrom ON (Closedround.round_id = Closedroundfrom.id)
			LEFT JOIN (
				SELECT Acluserscsvstore.id, Acluserscsvstore.user_id, Acluserscsvstore.csvstore_id, Assignedroundfrom.uts_round_until, Storeswithtasks.round_id 
				FROM acluserscsvstores AS Acluserscsvstore 
				LEFT JOIN users AS User ON (Acluserscsvstore.user_id = User.id) 
				LEFT JOIN rounds AS Assignedroundfrom ON (Acluserscsvstore.round_id_from = Assignedroundfrom.id) 
				LEFT JOIN ( 
					SELECT Acltaskscsvstore.task_id, Acltaskscsvstore.csvstore_id, Task.isEnabled, Task.round_id, Task.manufacturer_id 
					FROM acltaskscsvstores AS Acltaskscsvstore 
					LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id) 
					WHERE Task.manufacturer_id = ".$selectedmanufacturerid."  AND Task.isEnabled='y' AND ( round_id =" . implode (" or round_id=",$round_ids) . ")
				) AS Storeswithtasks ON (Acluserscsvstore.csvstore_id = Storeswithtasks.csvstore_id) 
			
				WHERE User.role_id=2 AND Storeswithtasks.csvstore_id IS NOT NULL 
				GROUP BY Acluserscsvstore.user_id, Acluserscsvstore.csvstore_id, Storeswithtasks.round_id 
				ORDER BY Acluserscsvstore.user_id, Storeswithtasks.round_id
			) AS Assignedstores ON (Assignedstores.user_id = Closedround.user_id)
			
			WHERE Assignedstores.round_id = Closedround.round_id AND Assignedstores.uts_round_until < Closedroundfrom.uts_round_until 
			AND Closedround.manufacturer_id =".$selectedmanufacturerid." 
			GROUP BY Assignedstores.round_id, Assignedstores.user_id
			ORDER BY Assignedstores.user_id, Assignedstores.round_id
			");
			 ALT 12.04.2010 */
			
			//Reps die dem ausgewählten Hersteller zugeteilt sind werden herausgefiltert
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("manufacturer_id =".$selectedmanufacturerid. " AND User.role_id=2 AND User.isEnabled='y' ORDER BY User.last_name");
			
			
			//************************* Auswertung SalesRep Ranking *******************************
			// NEU 12.04.2010 Query beinhaltet nun auch die Märkte Pro besuchsrunde (Sind jene Märkte bei denen in Stockchecks mindestens ein Produkt beim check auf 
			// Stand war, siehe Tabelle StorePerRound)
			
			$query = $this->Stockcheck->query("
			SELECT * 
			FROM( 	
				SELECT user_id, round_id, COUNT(DISTINCT csvstore_id) AS storesPerRound
				FROM stockchecks, csvproducts 
				WHERE stockchecks.csvproduct_id = csvproducts.id AND csvproducts.manufacturer_id = ".$selectedmanufacturerid."
				GROUP BY user_id, round_id
			) AS StorePerRound,
			(
				SELECT SUM(Statistics.productAvailable) as productAvailable, Statistics.user_id, Statistics.description, Statistics.round_id, Statistics.productCategory, 
					Statistics.ClosedRoundId AS ClosedRoundId
					FROM(
						SELECT COUNT(Stockcheck.id) as productAvailable, Round.description, Stockcheck.user_id, Csvproduct.productCategory, Stockcheck.round_id , 
						Closedround.id as ClosedRoundId, Stockcheck.csvstore_id , Storeswithtasks.csvstore_id AS Storewithtask_id
						FROM closedrounds AS Closedround
						LEFT JOIN rounds AS Round ON (Closedround.round_id = Round.id) 
						LEFT JOIN stockchecks AS Stockcheck ON (Closedround.round_id = Stockcheck.round_id)
						LEFT JOIN csvproducts AS Csvproduct ON (Stockcheck.csvproduct_id = Csvproduct.id)  
						LEFT JOIN csvstores AS Csvstore ON (Stockcheck.csvstore_id = Csvstore.id) 
						LEFT JOIN (
							SELECT Acltaskscsvstore.csvstore_id, Task.round_id, Task.manufacturer_id
							FROM acltaskscsvstores AS Acltaskscsvstore
							LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id)
							LEFT JOIN csvstores AS Csvstore ON (Acltaskscsvstore.csvstore_id = Csvstore.id) 
							WHERE Task.manufacturer_id = ".$selectedmanufacturerid." AND Task.isEnabled='y'
							GROUP BY Acltaskscsvstore.csvstore_id, Task.round_id
							ORDER BY Acltaskscsvstore.task_id
							) AS Storeswithtasks ON (Stockcheck.csvstore_id = Storeswithtasks.csvstore_id)
								
						WHERE Csvproduct.manufacturer_id = ".$selectedmanufacturerid." AND Closedround.manufacturer_id = ".$selectedmanufacturerid." 
						AND Csvproduct.productCategory='A' AND Stockcheck.stock > 0 
						AND Stockcheck.user_id = Closedround.user_id  AND Storeswithtasks.csvstore_id IS NOT NULL AND Storeswithtasks.round_id = Closedround.round_id
						Group BY Stockcheck.user_id, Stockcheck.round_id, Stockcheck.csvstore_id, Closedround.id
						ORDER BY Stockcheck.round_id
					) AS Statistics
					Group BY Statistics.user_id, Statistics.round_id, Statistics.ClosedRoundId
			) AS Statistic
			WHERE StorePerRound.user_id = Statistic.user_id AND StorePerRound.round_id =  Statistic.round_id
			");
			
		
			/* ALT == 12.04.2010 Problem Märkte die einem Rep nicht mehr zugewiesen waren wurden nicht gewertet. zb vorher 8 Märkte in einer KW nun 4 Märkte -->
			Ergebnis verfälscht, daher wid die untenstehende Query erweitert. 
			
			$query = $this->Stockcheck->query("
			SELECT SUM(Statistic.productAvailable) as productAvailable, Statistic.user_id, Statistic.description, Statistic.round_id, Statistic.productCategory, 
			Statistic.ClosedRoundId AS ClosedRoundId
			FROM(
				SELECT COUNT(Stockcheck.id) as productAvailable, Round.description, Stockcheck.user_id, Csvproduct.productCategory, Stockcheck.round_id , 
				Closedround.id as ClosedRoundId, Stockcheck.csvstore_id , Storeswithtasks.csvstore_id AS Storewithtask_id
				FROM closedrounds AS Closedround
				LEFT JOIN rounds AS Round ON (Closedround.round_id = Round.id) 
				LEFT JOIN stockchecks AS Stockcheck ON (Closedround.round_id = Stockcheck.round_id)
				LEFT JOIN csvproducts AS Csvproduct ON (Stockcheck.csvproduct_id = Csvproduct.id)  
				LEFT JOIN csvstores AS Csvstore ON (Stockcheck.csvstore_id = Csvstore.id) 
				LEFT JOIN (
					SELECT Acltaskscsvstore.csvstore_id, Task.round_id, Task.manufacturer_id
					FROM acltaskscsvstores AS Acltaskscsvstore
					LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id)
					LEFT JOIN csvstores AS Csvstore ON (Acltaskscsvstore.csvstore_id = Csvstore.id) 
					WHERE Task.manufacturer_id = ".$selectedmanufacturerid." AND Task.isEnabled='y'
					GROUP BY Acltaskscsvstore.csvstore_id, Task.round_id
					ORDER BY Acltaskscsvstore.task_id
					) AS Storeswithtasks ON (Stockcheck.csvstore_id = Storeswithtasks.csvstore_id)
			
				WHERE Csvproduct.manufacturer_id =".$selectedmanufacturerid." AND Closedround.manufacturer_id =".$selectedmanufacturerid." 
				AND Csvproduct.productCategory='A' AND Stockcheck.stock > 0 
				AND Stockcheck.user_id = Closedround.user_id  AND Storeswithtasks.csvstore_id IS NOT NULL AND Storeswithtasks.round_id = Closedround.round_id
				Group BY Stockcheck.user_id, Stockcheck.round_id, Stockcheck.csvstore_id, Closedround.id
				ORDER BY Stockcheck.round_id
				) AS Statistic
			Group BY Statistic.user_id, Statistic.round_id, Statistic.ClosedRoundId
			");
			*/
			
			// schleife über alle user, die gelistet werden sollen
			foreach ($assignedmanufacturers as $assignedmanufacturer) {
				
				$totalProductAvailability = 0;	
				$repName = $assignedmanufacturer["User"]["username"];
				$statistics[$repName] = $assignedmanufacturer["User"];
				
				$roundCnt = 0;
				// schleife um verfügbarkeit zu berechnen
				foreach ($closedrounds as $round) {
				
					$storesPerRep = 0;
					
					//$storesWithTasks = array();
					
					/* ALT: 
					foreach($assignedcsvstores as $assignedcsvstore) {
						
						//Es wird überprüft ob der Markt eine Auftrag hatte, ansonsten wird er nicht gewertet
						$storeHasTasks = 0;
						foreach ($tasks as $task) {
					
						// Wenn ein Store einen Auftrag hat wird er in array storesWithTasks geschrieben, das alle anderen Abfragen verwenden!!
							if ($task["Acltaskscsvstore"]["csvstore_id"] == $assignedcsvstore["Csvstore"]["id"] && $task["Task"]["round_id"] == $round['Round']["id"]) {
								$storeHasTasks = 1;
								break;
							}
						}
						if ($storeHasTasks == 1) {
							
							// die MarktzuweisungDatum muss kleiner sein als das Rundenstartdatum und der Store muss zu dem User zugeordnet sein 
							// der die Runde auch abgeschlossen  hat, sonst wird der Store nicht gezählt
							if ($assignedcsvstore["Assignedroundfrom"]["uts_round_until"] < $round["Round"]["uts_round_from"] && $assignedcsvstore["Acluserscsvstore"]["user_id"] == $round["Closedround"]["user_id"] && $assignedcsvstore["Acluserscsvstore"]["user_id"] == $assignedmanufacturer["User"]["id"] ) {
								$storesPerRep++;
								//alle Märkte die gezählt werden und die ein dieser Runde einen auftrag hatten wird in das array geschrieben
								//array_push($storesWithTasks, $assignedcsvstore["Csvstore"]["id"]) ;
							}
						}
											
						// die MarktzuweisungDatum muss kleiner sein als das Rundenstartdatum und der Store muss zu dem User zugeordnet sein 
						// der die Runde auch abgeschlossen hat und die aktuell durchlaufene Runde muss = der Runde in $assignedcsvstore sein, sonst wird der Store nicht gezählt
						if ($assignedcsvstore["Assignedroundfrom"]["uts_round_until"] < $round["Round"]["uts_round_from"] && $assignedcsvstore["Acluserscsvstore"]["user_id"] == $round["Closedround"]["user_id"] && $assignedcsvstore["Acluserscsvstore"]["user_id"] == $assignedmanufacturer["User"]["id"] && $assignedcsvstore["Storeswithtasks"]["round_id"] == $round["Round"]["id"]) {
							$storesPerRep++;
							
						}
						
						****ALT: 12.04.2010, Märkte werden gleich in der Query ausgwertet 
						
						if ($assignedcsvstore["Closedround"]["closedround_user_id"] == $assignedmanufacturer["User"]["id"] 
						&& $assignedcsvstore["Closedround"]["Closedround_id"] == $round["Closedround"]["round_id"]) {
							
							$storesPerRep = $assignedcsvstore[0]["repstores"];
							break;
						}	
						***ALT: 12.04.2010, Märkte werden gleich in der Query ausgwertet
					}
					*/
					
					
					// Nur die ClosedRounds des jeweiligen Reps werden durchlaufen
					if ($round["Closedround"]["user_id"] == $assignedmanufacturer["User"]["id"]) {
				
						$roundCnt++;
						
						$productAvailable = 0; // Produkt ist lagernd (Ist-Wert)
						$productShouldBeAvailable = 0; // Alle Produkte die lagenrd sein sollten (Soll-Wert)
						$productAvailability = 0; //Verfügbarkeit pro Woche
						
						// schleife über alle A-produkte (Soll-produkte) des herstellers
						foreach ($csvproducts as $csvproduct) {
						
							//hier wird überprüft ob das eol Datum(Anfang der KW) des aktuellen Produkts > ist als das aktuelle Datum(Ende der KW) und
							//ob das Produkt Einfügedatum(Ende der KW) kleiner ist als der Rundenanfang der aktuellen KW (und ob das Produkt zu überprüfen war)
							if (($csvproduct["Round"]["uts_round_from"] > $round["Round"]["uts_round_until"] || $csvproduct["Csvproduct"]["eol_round_id"] == 0) && $csvproduct["InsertedInRound"]["uts_round_until"] < $round["Round"]["uts_round_from"]) {
								$productShouldBeAvailable++;

							}
						}
						// produkt war lagernd
						//if ($productAvailable > 0) {
							// verfügbarkeit der runde
							// vergügbarkeit der runde = ist/soll
							// ist ... anzahl der verfügbaren produkte in allen stores
							// soll .. anzahl der proudkte * anzahl der märkte
						foreach ($query as $queries) {
										
							if ($queries["Statistic"]["ClosedRoundId"] == $round["Closedround"]["id"] && $queries["Statistic"]["round_id"] == $round["Round"]["id"] && $queries["Statistic"]["user_id"] == $assignedmanufacturer["User"]["id"]) {
							
								$storesPerRep = $queries["StorePerRound"]["storesPerRound"];
								
								$productAvailable = $queries["Statistic"]["productAvailable"];
								if ($storesPerRep > 0) {
									$productAvailability = $productAvailability + ($productAvailable / ($productShouldBeAvailable * $storesPerRep));
								}
								$totalProductAvailability = $totalProductAvailability + $productAvailability;
							}
						}
						//}
						
						$statistics[$repName][$round["Round"]["description"]]["CloseRounCnt = ".$roundCnt]["verf. pro Runde"] = $productAvailability; 
						$statistics[$repName][$round["Round"]["description"]]["CloseRounCnt = ".$roundCnt]["info"] = "[Produkte lagernd = ".$productAvailable. ", produkte soll = ".$productShouldBeAvailable * $storesPerRep.", Maerkte = ".$storesPerRep.", totale Verf. = ".$totalProductAvailability."]";
						//$statistics[$repName][$round["Round"]["description"]]["CloseRounCnt = ".$roundCnt]["StoresWithTasks"] = $storesWithTasks;
					}	
				}// closed Round
				// dividiert durch Rundenanzahl da ja Stockchecks über alle Runden hinweg gezählt wird, *100 da in Prozent
				if ($roundCnt > 0) { // für division by zero
					$statistics[$repName]["availability"] = ($totalProductAvailability/$roundCnt) * 100;
				} else {
					$statistics[$repName]["availability"] = 0;
				}
			}
			//print_r($statistics);
			//print_r($query);
			usort($statistics, "helper_sort_rep_ranking");
			$this->set(compact('statistics'));
		}
	}
	
	
	
	function availabilityperchain() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			//Alle Runden werden berücksichtig bis(inklusive) zur aktuellen KW
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until desc "  );
			$this->set(compact('rounds'));
			
			$this->set(compact('selectedroundid'));
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$chains = $this->Chain->findAll("Chain.isEnabled = 'y' ORDER BY name asc");
			$this->set(compact('chains'));
			//$utsYearFrom = mktime(0,0,0,1,1,$selectedyear); // 1.1.2009 00:00:00
			//$utsYearUntil = mktime(0,0,-1,1,1,$selectedyear+1); // 31.12.2009 23:59:59

			//print_r($_REQUEST);
			
			//Kategorien werden manuell festgelegt da nicht in der Db vorhanden
			$categories = array('categoryA' => 'A', 'categoryB' => 'B', 'categoryC' => 'C');
			$this->set(compact("categories"));
			
			$statistics = array(); //im statistics array werden alle extrahierten Daten gespeichert
			$sumOfTotalProductAvailability = array();
			
			if(isset($_REQUEST['submit'])) {
				// für Sticky
				$selectedroundfromid = @$_REQUEST['selectedroundfromid'];
				$this->set(compact('selectedroundfromid')); 
				$selectedrounduntilid = @$_REQUEST['selectedrounduntilid'];
				$this->set(compact('selectedrounduntilid')); 
				$selectedcategory= @$_REQUEST['selectedcategory'];
				$this->set(compact('selectedcategory')); 
				
				
				foreach($rounds as $round) {
					//Uts_round_from der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedroundfromid) {
						$utsRoundFrom = $round["Round"]["uts_round_from"];
						//brauchen wir für die Zeitspannen Überprüfung, da die erste Runde ja uts_from = 0 ist.
						$utsRoundUntilRoundFrom = $round["Round"]["uts_round_until"]; 
					}
					//Uts_round_until der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedrounduntilid) {
						$utsRoundUntil = $round["Round"]["uts_round_until"];
					}
				}
				
				// liegt die ausgeählte Zeitspanne ber einem Jahr(31556926 Sekunden) wird eine Fehlermeldung ausgegeben
				if (($utsRoundUntil - $utsRoundUntilRoundFrom) > 31556926) {
					$this->Session->setFlash('<div class="error-message-new"><img src="/img/cross_icon_small.png" alt="Cross Icon" /> Die Zeitspanne darf maximal ein Jahr(53 Kws) betragen.</div>');
				} else {
				
				$rounds = $this->Round->getRoundsBetween($utsRoundFrom, $utsRoundUntil);
				$round_ids = $this->Round->getRoundIDsForRounds($rounds);
				
				$closedrounds = $this->Closedround->findAll("(round_id=".implode(" or round_id=", $round_ids).") AND manufacturer_id=".$selectedmanufacturerid);
				
				//$tasks = $this->Acltaskscsvstore->findAll("(round_id=".implode(" or round_id=", $round_ids).") AND manufacturer_id=".$selectedmanufacturerid." AND Task.isEnabled='y'");
	
				
				$csvproducts =  $this->Csvproduct->findAll("manufacturer_id =".$selectedmanufacturerid." AND productCategory='".$selectedcategory."'");
				
				
				//Reps die dem ausgewählten Hersteller zugeteilt sind werden herausgefiltert
				$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("manufacturer_id =".$selectedmanufacturerid. " AND User.role_id=2 AND User.isEnabled='y' ORDER BY User.last_name");
				//$user_ids = $this->Aclusersmanufacturer->getUserIDsForManufacturers($assignedmanufacturers);
				
				// Nur Einträge werden gewertet bei denene der User: ("manufacturer_id =".$selectedmanufacturerid. " AND User.role_id=2 AND User.isEnabled='y') ist 
				
				//hier wird auch berücksichtigt ob ein zugewiesener Markt einen Auftrag hat und es werden nur die Märkte gewertet bei denen die Runde abgeschlossen wurde
				/**alt 12.04.2010
				$assignedcsvstores = $this->Acluserscsvstore->query("
				SELECT COUNT(Assignedstores.csvstore_id) AS repstores, Closedround.user_id AS closedround_user_id, Assignedstores.user_id, Assignedstores.csvstore_id, 
				Assignedstores.uts_round_until AS uts_assignedstoresroundfrom, Closedroundfrom.uts_round_until AS uts_closedround_until, Closedround.round_id AS Closedround_id, 
				Assignedstores.round_id, Assignedstores.chain_id
				FROM closedrounds AS Closedround
				LEFT JOIN rounds AS Closedroundfrom ON (Closedround.round_id = Closedroundfrom.id)
				LEFT JOIN (
					SELECT Acluserscsvstore.id, Acluserscsvstore.user_id, Acluserscsvstore.csvstore_id, Assignedroundfrom.uts_round_until, Storeswithtasks.round_id,
					Csvstore.chain_id 
					FROM acluserscsvstores AS Acluserscsvstore
					LEFT JOIN csvstores AS Csvstore ON (Acluserscsvstore.csvstore_id = Csvstore.id)  
					LEFT JOIN users AS User ON (Acluserscsvstore.user_id = User.id) 
					LEFT JOIN rounds AS Assignedroundfrom ON (Acluserscsvstore.round_id_from = Assignedroundfrom.id) 
					LEFT JOIN ( 
						SELECT Acltaskscsvstore.task_id, Acltaskscsvstore.csvstore_id, Task.isEnabled, Task.round_id, Task.manufacturer_id 
						FROM acltaskscsvstores AS Acltaskscsvstore 
						LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id) 
						WHERE Task.manufacturer_id = ".$selectedmanufacturerid." AND Task.isEnabled='y' AND ( round_id =" . implode (" or round_id=",$round_ids) . ")
					) AS Storeswithtasks ON (Acluserscsvstore.csvstore_id = Storeswithtasks.csvstore_id) 
				
					WHERE User.role_id=2 AND Storeswithtasks.csvstore_id IS NOT NULL 
					GROUP BY Acluserscsvstore.user_id, Acluserscsvstore.csvstore_id, Storeswithtasks.round_id 
					ORDER BY Acluserscsvstore.user_id, Storeswithtasks.round_id
				) AS Assignedstores ON (Assignedstores.user_id = Closedround.user_id)
				
				WHERE Assignedstores.round_id = Closedround.round_id AND Assignedstores.uts_round_until < Closedroundfrom.uts_round_until
				AND Closedround.manufacturer_id =".$selectedmanufacturerid."  
				GROUP BY Assignedstores.round_id, Assignedstores.user_id, Assignedstores.chain_id
				ORDER BY Assignedstores.user_id, Assignedstores.round_id, Assignedstores.chain_id
				");
				alt 12.04.2010 */
				
				//$assignedcsvstores = $this->Acluserscsvstore->findAll("user_id=".implode(" or user_id=", $user_ids));
				
				
				//****************** Auswertung Verfügbarkeit pro Kette ************************
				// NEU 12.04.2010 Query beinhaltet nun zusätzlich die Märkte Pro besuchsrunde (Sind jene Märkte bei denen in Stockchecks mindestens ein Produkt beim check auf
				// Stand war, siehe Tabelle StorePerRound). Es werden nun nich  mehr die Märkte gezählt die einem Rep zugeteilt sind da dieses Zuteilung jederzeit verändert 
				// werden kann(Zuteilung wird gelogged aber Aufhebung nicht). $storesReps braucht nun nich extra berechnet werden. 
				//--> Umgestellt da wir Marktzuteilungen nur bedingt loggen
				foreach ($chains as $chain) {
					$chainName = $chain["Chain"]["name"];
					
					$query = $this->Stockcheck->query("
					SELECT * 
					FROM( 	
						SELECT user_id, round_id, COUNT(DISTINCT csvstore_id) AS storesPerRound
						FROM stockchecks, csvproducts, csvstores 
						WHERE stockchecks.csvproduct_id = csvproducts.id AND stockchecks.csvstore_id = csvstores.id
						AND csvproducts.manufacturer_id = ".$selectedmanufacturerid." AND csvstores.chain_id =".$chain["Chain"]["id"]."
						GROUP BY user_id, round_id
					) AS StorePerRound,
					(
						SELECT SUM(Statistics.productAvailable) as productAvailable, Statistics.user_id, Statistics.description, Statistics.round_id, 
						Statistics.productCategory, Statistics.ClosedRoundId AS ClosedRoundId
						FROM(
							SELECT COUNT(Stockcheck.id) as productAvailable, Round.description, Stockcheck.user_id, Csvproduct.productCategory, Stockcheck.round_id , 
							Closedround.id as ClosedRoundId, Stockcheck.csvstore_id , Storeswithtasks.csvstore_id AS Storewithtask_id
							FROM closedrounds AS Closedround
							LEFT JOIN rounds AS Round ON (Closedround.round_id = Round.id) 
							LEFT JOIN stockchecks AS Stockcheck ON (Closedround.round_id = Stockcheck.round_id)
							LEFT JOIN csvproducts AS Csvproduct ON (Stockcheck.csvproduct_id = Csvproduct.id)  
							LEFT JOIN csvstores AS Csvstore ON (Stockcheck.csvstore_id = Csvstore.id) 
							LEFT JOIN (
								SELECT Acltaskscsvstore.csvstore_id, Task.round_id, Task.manufacturer_id
								FROM acltaskscsvstores AS Acltaskscsvstore
								LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id)
								LEFT JOIN csvstores AS Csvstore ON (Acltaskscsvstore.csvstore_id = Csvstore.id) 
								WHERE Task.manufacturer_id = ".$selectedmanufacturerid." AND Task.isEnabled='y' AND Csvstore.chain_id =".$chain["Chain"]["id"]."
								GROUP BY Acltaskscsvstore.csvstore_id, Task.round_id
								ORDER BY Acltaskscsvstore.task_id
								) AS Storeswithtasks ON (Stockcheck.csvstore_id = Storeswithtasks.csvstore_id)
						
							WHERE Csvproduct.manufacturer_id =".$selectedmanufacturerid." AND Csvproduct.productCategory='".$selectedcategory."' AND Stockcheck.stock > 0 
							AND Csvstore.chain_id =".$chain["Chain"]["id"]." AND Stockcheck.user_id = Closedround.user_id  AND Storeswithtasks.csvstore_id IS NOT NULL
							AND Storeswithtasks.round_id = Closedround.round_id AND Closedround.manufacturer_id =".$selectedmanufacturerid."
							Group BY Stockcheck.user_id, Stockcheck.round_id, Stockcheck.csvstore_id, Closedround.id
							ORDER BY Stockcheck.round_id
						) AS Statistics
						Group BY Statistics.user_id, Statistics.round_id, Statistics.ClosedRoundId
					) AS Statistic
					WHERE StorePerRound.user_id = Statistic.user_id AND StorePerRound.round_id =  Statistic.round_id
					");
				
				
				/* alt 12.04.2010
				foreach ($chains as $chain) {
					$chainName = $chain["Chain"]["name"];
					
					$query = $this->Stockcheck->query("
					SELECT SUM(Statistic.productAvailable) as productAvailable, Statistic.user_id, Statistic.description, Statistic.round_id, Statistic.productCategory, 
					Statistic.ClosedRoundId AS ClosedRoundId
					FROM(
						SELECT COUNT(Stockcheck.id) as productAvailable, Round.description, Stockcheck.user_id, Csvproduct.productCategory, Stockcheck.round_id , 
						Closedround.id as ClosedRoundId, Stockcheck.csvstore_id , Storeswithtasks.csvstore_id AS Storewithtask_id
						FROM closedrounds AS Closedround
						LEFT JOIN rounds AS Round ON (Closedround.round_id = Round.id) 
						LEFT JOIN stockchecks AS Stockcheck ON (Closedround.round_id = Stockcheck.round_id)
						LEFT JOIN csvproducts AS Csvproduct ON (Stockcheck.csvproduct_id = Csvproduct.id)  
						LEFT JOIN csvstores AS Csvstore ON (Stockcheck.csvstore_id = Csvstore.id) 
						LEFT JOIN (
							SELECT Acltaskscsvstore.csvstore_id, Task.round_id, Task.manufacturer_id
							FROM acltaskscsvstores AS Acltaskscsvstore
							LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id)
							LEFT JOIN csvstores AS Csvstore ON (Acltaskscsvstore.csvstore_id = Csvstore.id) 
							WHERE Task.manufacturer_id = ".$selectedmanufacturerid." AND Task.isEnabled='y' AND Csvstore.chain_id =".$chain["Chain"]["id"]."
							GROUP BY Acltaskscsvstore.csvstore_id, Task.round_id
							ORDER BY Acltaskscsvstore.task_id
							) AS Storeswithtasks ON (Stockcheck.csvstore_id = Storeswithtasks.csvstore_id)
					
						WHERE Csvproduct.manufacturer_id =".$selectedmanufacturerid." AND Csvproduct.productCategory='".$selectedcategory."' AND Stockcheck.stock > 0 
						AND Csvstore.chain_id =".$chain["Chain"]["id"]." AND Stockcheck.user_id = Closedround.user_id  AND Storeswithtasks.csvstore_id IS NOT NULL
						AND Storeswithtasks.round_id = Closedround.round_id AND Closedround.manufacturer_id =".$selectedmanufacturerid."
						Group BY Stockcheck.user_id, Stockcheck.round_id, Stockcheck.csvstore_id, Closedround.id
						ORDER BY Stockcheck.round_id
						) AS Statistic
					Group BY Statistic.user_id, Statistic.round_id, Statistic.ClosedRoundId
					");
					alt 12.04.2010*/
					
					//print_r($assignedcsvstores);
					
					$sumTotalProductAvailabilityRound = 0;
					// schleife über alle Runde(RundeVon - RundeBis), die gelistet werden sollen
					$roundCnt = 0;
					
					foreach ($rounds as $round) {
						//$roundCnt++;
						$totalProductAvailability = 0;
							
						$roundName = $round["Round"]["description"];
						
						$closedroundCnt = 0;
						// Schleife über alle geschlossenen Runden (pro Rep und pro ausgewählten Hersteller) werden durchlaufen um Verfügbarkeit zu berechnen
						foreach ($closedrounds as $closedround) {
						
							$storesWithTasks = array();
							
							if ($closedround["Closedround"]["round_id"] == $round["Round"]["id"]) {
								//$closedroundCnt++;
								
								$storesReps = 0;
								// Die Märkte werden pro SalesRep und pro ClosedRound gezählt, wenn der Markt in der aktuellen Runde, dem User der die Runde geschlossen hat, zugewiesen war.					
								/**alt 12.04.2010
								foreach($assignedcsvstores as $assignedcsvstore) {
									
									/*
									//Es wird überprüft ob der Markt eine Auftrag hatte, ansonsten wird er nicht gewertet
									$storeHasTasks = 0;
									foreach ($tasks as $task) {
								
									// Wenn ein Store einen Auftrag hat wird er in array storesWithTasks geschrieben, das alle anderen Abfragen verwenden!!
										if ($task["Csvstore"]["id"] == $assignedcsvstore["Csvstore"]["id"] && $task["Task"]["round_id"] == $round['Round']["id"]) {
											$storeHasTasks = 1;
											break;
										}
									}
									if ($storeHasTasks == 1) {
									
										// die MarktzuweisungDatum muss kleiner sein als das Rundenstartdatum und der Store muss zu dem User zugeordnet sein 
										// der die Runde auch abgeschlossen  hat, sonst wird der Store nicht gezählt
										if ($assignedcsvstore["Assignedroundfrom"]["uts_round_until"] < $closedround["Round"]["uts_round_from"] && $assignedcsvstore["Acluserscsvstore"]["user_id"] == $closedround["Closedround"]["user_id"] && $assignedcsvstore["Csvstore"]["chain_id"] == $chain["Chain"]["id"]) {
											$storesReps++;
											
											//alle Märkte die gezählt werden und die ein dieser Runde einen auftrag hatten wird in das array geschrieben
											//array_push($storesWithTasks, $assignedcsvstore["Csvstore"]["id"]) ;
											//echo "********* ".$assignedcsvstore["Csvstore"]["id"];
											
										}
									}
									
									/**alt 12.04.2010
									if ($assignedcsvstore["Closedround"]["closedround_user_id"] == $closedround["Closedround"]["user_id"]  && $assignedcsvstore["Assignedstores"]["chain_id"] == $chain["Chain"]["id"] && $assignedcsvstore["Closedround"]["Closedround_id"] == $closedround["Closedround"]["round_id"]) {
										$storesReps = $assignedcsvstore[0]["repstores"];
										break;
									}
									/**alt 12.04.2010
								}
								**alt 12.04.2010 */ 

								$productAvailable = 0; // Produkt ist lagernd (Ist-Wert)
								$productShouldBeAvailable = 0; // Alle Produkte die lagenrd sein sollten (Soll-Wert)
								$productAvailability = 0; //Verfügbarkeit pro Woche
								
								// schleife über alle A-produkte (Soll-produkte) des herstellers
								foreach ($csvproducts as $csvproduct) {
								
									//hier wird überprüft ob das eol Datum(Anfang der KW) des aktuellen Produkts > ist als das aktuelle Datum(Ende der KW) und
									//ob das Produkt Einfügedatum(Ende der KW) kleiner ist als der Rundenanfang der aktuellen KW (alt :und ob das Produkt zu überprüfen war)
									if (($csvproduct["Round"]["uts_round_from"] > $closedround["Round"]["uts_round_until"] || $csvproduct["Csvproduct"]["eol_round_id"] == 0) && $csvproduct["InsertedInRound"]["uts_round_until"] < $closedround["Round"]["uts_round_from"]) {
										$productShouldBeAvailable++;
									
									}
								}
								// produkt war lagernd $productAvailable > 0 &&
								//*** alt 12.04.2010 
								
								foreach ($query as $queries) {
										
									if ($queries["Statistic"]["ClosedRoundId"] == $closedround["Closedround"]["id"] && $queries["Statistic"]["round_id"] == $round["Round"]["id"]) {								
										$storesReps = $queries["StorePerRound"]["storesPerRound"];
										break;
									}
								}
								
								if ( $storesReps > 0) {
								//*** alt 12.04.2010
									//Der Rep der die Runde abgeschlossen hat, muss mindestens einen Markt haben sonst wird die closedRound nicht gezählt(pro Kette)
									$closedroundCnt++;
									// verfügbarkeit pro closedRound
									// vergügbarkeit der runde = ist/soll
									// ist ... anzahl der verfügbaren produkte in diser Runde (in allen Märkten)
									// soll .. anzahl der proudkte * anzahl der märkte
									
									foreach ($query as $queries) {
										
										if ($queries["Statistic"]["ClosedRoundId"] == $closedround["Closedround"]["id"] && $queries["Statistic"]["round_id"] == $round["Round"]["id"]) {
											//NEU 12.04.2010 
											//$storesReps = $queries["StorePerRound"]["storesPerRound"];
											
											$productAvailable = $queries["Statistic"]["productAvailable"];
											$productAvailability = $productAvailability + ($productAvailable/ ($productShouldBeAvailable * $storesReps));
											$totalProductAvailability = $totalProductAvailability + $productAvailability;
										}
									}

									$statistics[$roundName][$chainName]["abgeschl. ".$closedround["Round"]["description"]]["CloseRounCnt = ".$closedroundCnt]["Rep der abgeschlossen hat"] = $closedround["User"]["username"].", id = ".$closedround["User"]["id"];
								$statistics[$roundName][$chainName]["abgeschl. ".$closedround["Round"]["description"]]["CloseRounCnt = ".$closedroundCnt]["verf. pro Runde"] = $productAvailability; 
								$statistics[$roundName][$chainName]["abgeschl. ".$closedround["Round"]["description"]]["CloseRounCnt = ".$closedroundCnt]["info"] = "[Produkte lagernd = ".$productAvailable. ", produkte soll = ".$productShouldBeAvailable * $storesReps.", Maerkte = ".$storesReps.", totale Verf. = ".$totalProductAvailability."]";
								$statistics[$roundName][$chainName]["abgeschl. ".$closedround["Round"]["description"]]["CloseRounCnt = ".$closedroundCnt]["StoresWithTasks"] = $storesWithTasks;		
								} //$storesReps > 0
								
								
							}// closedround
						}// $closedround["Closedround"]["round_id"] == $round["Round"]["id"]
						if ($closedroundCnt > 0) { // für division by zero
						
							// dividiert durch geschlossene Rundenanzahl da ja Stockchecks über alle Runden hinweg gezählt wird, *100 da in Prozent
							$statistics[$roundName][$chainName]["availability"] = ($totalProductAvailability/$closedroundCnt) * 100; 
						} else {
							$statistics[$roundName][$chainName]["availability"] = 0;
						}
						
						// Wenn die Verfügbarkeit einer Runde 0 ist dh. wenn keine Aufträge(Tasks) für einen Markt abgegeben wurden oder wenn noch keine Runde für einen Markt
						// in der aktuellen KW abgeschlossen wurde, wird ader Rundencounter nicht erhöht.
						if ($statistics[$roundName][$chainName]["availability"] != 0) {
							$roundCnt++;
						}
						//Summe über alle Verfügbarkeiten pro KW werden hier ermittelt
						$sumTotalProductAvailabilityRound = $sumTotalProductAvailabilityRound + $statistics[$roundName][$chainName]["availability"];
					}//$rounds
					
					if ($roundCnt > 0) { // für division by zero
						$sumOfTotalProductAvailability[$chainName]["totalAvailability"] = $sumTotalProductAvailabilityRound/$roundCnt;
					} else {
						$sumOfTotalProductAvailability[$chainName]["totalAvailability"] = 0;
					}
				}//chains
				}//Zeitspanne über einem Jahr?
			}// isset submit
		}
		//print_r($statistics);
		//print_r($query);
		$this->set(compact('statistics'));
		$this->set(compact('sumOfTotalProductAvailability'));
		
		//echo "Did nothing in $time seconds\n";
	}
	
	
	
	function availabilityperstore() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			//Alle Märkte werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID(),null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores[0]['Csvstore']['id']);
			$this->set(compact('selectedcsvstoreid'));
			
			//Alle Runden werden berücksichtig bis(inklusive) zur aktuellen KW
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until desc " );
			$this->set(compact('rounds'));
			
			$this->set(compact('selectedroundid'));
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			//$chains = $this->Chain->findAll("ORDER BY name asc");
			//$this->set(compact('chains'));
			//$utsYearFrom = mktime(0,0,0,1,1,$selectedyear); // 1.1.2009 00:00:00
			//$utsYearUntil = mktime(0,0,-1,1,1,$selectedyear+1); // 31.12.2009 23:59:59

			//print_r($_REQUEST);
			
			//Kategorien werden manuell festgelegt da nicht in der Db vorhanden
			$categories = array('categoryA' => 'A', 'categoryB' => 'B', 'categoryC' => 'C');
			$this->set(compact("categories"));
			
			$statistics = array(); //im statistics array werden alle extrahierten Daten gespeichert
			$sumOfTotalProductAvailability = array();
	
			if(isset($_REQUEST['submit'])) {
				
				// für Sticky
				$selectedroundfromid = @$_REQUEST['selectedroundfromid'];
				$this->set(compact('selectedroundfromid')); 
				$selectedrounduntilid = @$_REQUEST['selectedrounduntilid'];
				$this->set(compact('selectedrounduntilid')); 
				$selectedcategory= @$_REQUEST['selectedcategory'];
				$this->set(compact('selectedcategory')); 
				
				foreach($rounds as $round) {
					//Uts_round_from der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedroundfromid) {
						$utsRoundFrom = $round["Round"]["uts_round_from"];
						//brauchen wir für die Zeitspannen Überprüfung, da die erste Runde ja uts_from = 0 ist.
						$utsRoundUntilRoundFrom = $round["Round"]["uts_round_until"]; 
					}
					//Uts_round_until der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedrounduntilid) {
						$utsRoundUntil = $round["Round"]["uts_round_until"];
					}
				}
				
				// liegt die ausgeählte Zeitspanne über einem Jahr(31556926 Sekunden) wird eine Fehlermeldung ausgegeben
				if (($utsRoundUntil - $utsRoundUntilRoundFrom) > 31556926) {
					$this->Session->setFlash('<div class="error-message-new"><img src="/img/cross_icon_small.png" alt="Cross Icon" /> Die Zeitspanne darf maximal ein Jahr(53 Kws) betragen.</div>');
				} else {
				
					$rounds = $this->Round->getRoundsBetween($utsRoundFrom, $utsRoundUntil);
					$round_ids = $this->Round->getRoundIDsForRounds($rounds);
					
					$closedrounds = $this->Closedround->findAll("(round_id=".implode(" or round_id=", $round_ids).") AND manufacturer_id=".$selectedmanufacturerid);
					
					//$tasks = $this->Acltaskscsvstore->findAll("(round_id=".implode(" or round_id=", $round_ids).") AND manufacturer_id=".$selectedmanufacturerid." AND Task.isEnabled='y'");
		
					//$stockchecks =  $this->Stockcheck->findAll("csvstore_id =".$selectedcsvstoreid." AND Csvproduct.manufacturer_id =".$selectedmanufacturerid." AND Csvproduct.productCategory='".$selectedcategory."' AND ( round_id=" . implode (" or round_id=",$round_ids) . ")");
					
					$csvproducts =  $this->Csvproduct->findAll("manufacturer_id =".$selectedmanufacturerid." AND productCategory='".$selectedcategory."'");
					
					
					//Reps die dem ausgewählten Hersteller zugeteilt sind werden herausgefiltert
					$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("manufacturer_id =".$selectedmanufacturerid. " AND User.role_id=2 AND User.isEnabled='y' ORDER BY User.last_name");
					$user_ids = $this->Aclusersmanufacturer->getUserIDsForManufacturers($assignedmanufacturers);
					
					// Nur Einträge werden gewertet bei denene der User: ("manufacturer_id =".$selectedmanufacturerid. " AND User.role_id=2 AND User.isEnabled='y') ist 
					// Es können auch mehrere User einen Markt betreuen
					//$csvstores = $this->Acluserscsvstore->findAll("csvstore_id =".$selectedcsvstoreid." AND user_id=".implode(" OR csvstore_id =".$selectedcsvstoreid." AND user_id=",$user_ids));

					
					//------------------------------------------------- Auswertung Verfügbarkeit pro Markt ------------------------------------------------
					$query = $this->Stockcheck->query("
					SELECT * 
					FROM( 	
						SELECT user_id, round_id, COUNT(DISTINCT csvstore_id) AS storesPerRound
						FROM stockchecks, csvproducts, csvstores 
						WHERE stockchecks.csvproduct_id = csvproducts.id AND stockchecks.csvstore_id = csvstores.id
						AND csvproducts.manufacturer_id = ".$selectedmanufacturerid." AND csvstores.id =".$selectedcsvstoreid."
						GROUP BY user_id, round_id
					) AS StorePerRound,
					(
					SELECT SUM(Statistics.productAvailable) as productAvailable, Statistics.user_id, Statistics.description, Statistics.round_id, Statistics.productCategory, 
					Statistics.ClosedRoundId AS ClosedRoundId
					FROM(
						SELECT COUNT(Stockcheck.id) as productAvailable, Round.description, Stockcheck.user_id, Csvproduct.productCategory, Stockcheck.round_id , 
						Closedround.id as ClosedRoundId, Stockcheck.csvstore_id , Storeswithtasks.csvstore_id AS Storewithtask_id
						FROM closedrounds AS Closedround
						LEFT JOIN rounds AS Round ON (Closedround.round_id = Round.id) 
						LEFT JOIN stockchecks AS Stockcheck ON (Closedround.round_id = Stockcheck.round_id)
						LEFT JOIN csvproducts AS Csvproduct ON (Stockcheck.csvproduct_id = Csvproduct.id)  
						LEFT JOIN csvstores AS Csvstore ON (Stockcheck.csvstore_id = Csvstore.id) 
						LEFT JOIN (
							SELECT Acltaskscsvstore.csvstore_id, Task.round_id, Task.manufacturer_id
							FROM acltaskscsvstores AS Acltaskscsvstore
							LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id)
							LEFT JOIN csvstores AS Csvstore ON (Acltaskscsvstore.csvstore_id = Csvstore.id) 
							WHERE Task.manufacturer_id = ".$selectedmanufacturerid." AND Task.isEnabled='y' AND Csvstore.id =".$selectedcsvstoreid."
							GROUP BY Acltaskscsvstore.csvstore_id, Task.round_id
							ORDER BY Acltaskscsvstore.task_id
							) AS Storeswithtasks ON (Stockcheck.csvstore_id = Storeswithtasks.csvstore_id)
					
						WHERE Csvproduct.manufacturer_id =".$selectedmanufacturerid." AND Csvproduct.productCategory='".$selectedcategory."' AND Stockcheck.stock > 0 
						AND Csvstore.id =".$selectedcsvstoreid." AND Closedround.manufacturer_id =".$selectedmanufacturerid." 
						AND Stockcheck.user_id = Closedround.user_id  AND Storeswithtasks.csvstore_id IS NOT NULL
						AND Storeswithtasks.round_id = Closedround.round_id
						Group BY Stockcheck.user_id, Stockcheck.round_id, Stockcheck.csvstore_id, Closedround.id
						ORDER BY Stockcheck.round_id
						) AS Statistics
					Group BY Statistics.user_id, Statistics.round_id, Statistics.ClosedRoundId
					) AS Statistic
					WHERE StorePerRound.user_id = Statistic.user_id AND StorePerRound.round_id =  Statistic.round_id
					");
					
					/* alt 20.4.2010
					$query = $this->Stockcheck->query("
					SELECT SUM(Statistic.productAvailable) as productAvailable, Statistic.user_id, Statistic.description, Statistic.round_id, Statistic.productCategory, 
					Statistic.ClosedRoundId AS ClosedRoundId
					FROM(
						SELECT COUNT(Stockcheck.id) as productAvailable, Round.description, Stockcheck.user_id, Csvproduct.productCategory, Stockcheck.round_id , 
						Closedround.id as ClosedRoundId, Stockcheck.csvstore_id , Storeswithtasks.csvstore_id AS Storewithtask_id
						FROM closedrounds AS Closedround
						LEFT JOIN rounds AS Round ON (Closedround.round_id = Round.id) 
						LEFT JOIN stockchecks AS Stockcheck ON (Closedround.round_id = Stockcheck.round_id)
						LEFT JOIN csvproducts AS Csvproduct ON (Stockcheck.csvproduct_id = Csvproduct.id)  
						LEFT JOIN csvstores AS Csvstore ON (Stockcheck.csvstore_id = Csvstore.id) 
						LEFT JOIN (
							SELECT Acltaskscsvstore.csvstore_id, Task.round_id, Task.manufacturer_id
							FROM acltaskscsvstores AS Acltaskscsvstore
							LEFT JOIN tasks AS Task ON (Acltaskscsvstore.task_id = Task.id)
							LEFT JOIN csvstores AS Csvstore ON (Acltaskscsvstore.csvstore_id = Csvstore.id) 
							WHERE Task.manufacturer_id = ".$selectedmanufacturerid." AND Task.isEnabled='y' AND Csvstore.id =".$selectedcsvstoreid."
							GROUP BY Acltaskscsvstore.csvstore_id, Task.round_id
							ORDER BY Acltaskscsvstore.task_id
							) AS Storeswithtasks ON (Stockcheck.csvstore_id = Storeswithtasks.csvstore_id)
					
						WHERE Csvproduct.manufacturer_id =".$selectedmanufacturerid." AND Csvproduct.productCategory='".$selectedcategory."' AND Stockcheck.stock > 0 
						AND Csvstore.id =".$selectedcsvstoreid." AND Closedround.manufacturer_id =".$selectedmanufacturerid." 
						AND Stockcheck.user_id = Closedround.user_id  AND Storeswithtasks.csvstore_id IS NOT NULL
						AND Storeswithtasks.round_id = Closedround.round_id
						Group BY Stockcheck.user_id, Stockcheck.round_id, Stockcheck.csvstore_id, Closedround.id
						ORDER BY Stockcheck.round_id
						) AS Statistic
					Group BY Statistic.user_id, Statistic.round_id, Statistic.ClosedRoundId
					");
					alt 20.4.2010 */
					$sumTotalProductAvailabilityRound = 0;
					
					//$totalProductAvailability = 0;
					// schleife über alle Runde(RundeVon - RundeBis), die gelistet werden sollen
					$roundCnt = 0;
					
					foreach ($rounds as $round) {
						
						$totalProductAvailability = 0;
						//$roundCnt++;
						$roundName = $round["Round"]["description"];
						//$statistics[$roundName] = $round["Round"]["description"];
	
						$closedroundCnt = 0;
						// Schleife über alle geschlossenen Runden (pro Rep und pro ausgewählten Hersteller) werden durchlaufen um Verfügbarkeit zu berechnen
						
						foreach ($closedrounds as $closedround) {
							
							//$storesWithTasks = array();
							
							if ($closedround["Closedround"]["round_id"] == $round["Round"]["id"]) {
								//$closedroundCnt++;
								
								$storesReps = 0;
								// alle Märkte werden des Reps werden pro ClosedRound gezählt, wenn der Markt in der aktuellen Runde, dem User der die Runde geschlossen hat, zugewiesen war.
								
								$productAvailable = 0; // Produkt ist lagernd (Ist-Wert)
								$productShouldBeAvailable = 0; // Alle Produkte die lagenrd sein sollten (Soll-Wert)
								$productAvailability = 0; //Verfügbarkeit pro Woche
								
								// schleife über alle A-produkte (Soll-produkte) des herstellers
								foreach ($csvproducts as $csvproduct) {
								
									//hier wird überprüft ob das eol Datum(Anfang der KW) des aktuellen Produkts > ist als das aktuelle Datum(Ende der KW) und
									//ob das Produkt Einfügedatum(Ende der KW) kleiner ist als der Rundenanfang der aktuellen KW (alt :und ob das Produkt zu überprüfen war)
									if (($csvproduct["Round"]["uts_round_from"] > $closedround["Round"]["uts_round_until"] || $csvproduct["Csvproduct"]["eol_round_id"] == 0) && $csvproduct["InsertedInRound"]["uts_round_until"] < $closedround["Round"]["uts_round_from"]) {
										$productShouldBeAvailable++;
									}
								}
								
								//if ($storesReps > 0) {
									// verfügbarkeit pro closedRound
									// vergügbarkeit der runde = ist/soll
									// ist ... anzahl der verfügbaren produkte in diser Runde (in allen Märkten)
									// soll .. anzahl der proudkte * anzahl der märkte
									
								foreach ($query as $queries) {
									
									if ($queries["Statistic"]["ClosedRoundId"] == $closedround["Closedround"]["id"] && $queries["Statistic"]["round_id"] == $round["Round"]["id"]) {
										//Anzahl der Stores --> In dieser funktion gibt es immer nur einen Markt
										$storesReps = $queries["StorePerRound"]["storesPerRound"];
										
										$productAvailable = $queries["Statistic"]["productAvailable"];
										$productAvailability = $productAvailability + ($productAvailable/ ($productShouldBeAvailable * $storesReps));
										$totalProductAvailability = $totalProductAvailability + $productAvailability;
										
										if ($queries["StorePerRound"]["storesPerRound"] > 0) {
											//Der Rep der die Runde abgeschlossen hat, muss mindestens einen Markt besucht haben sonst wird die closedRound nicht gezählt(pro Kette)
											$closedroundCnt++;
											
											$statistics[$roundName]["abgeschl. ".$closedround["Round"]["description"]]["CloseRounCnt = ".$closedroundCnt]["Rep der abgeschlossen hat"] = $closedround["User"]["username"].", id = ".$closedround["User"]["id"];
											$statistics[$roundName]["abgeschl. ".$closedround["Round"]["description"]]["CloseRounCnt = ".$closedroundCnt]["verf. pro Runde"] = $productAvailability; 
											$statistics[$roundName]["abgeschl. ".$closedround["Round"]["description"]]["CloseRounCnt = ".$closedroundCnt]["info"] = "[Produkte lagernd = ".$productAvailable. ", produkte soll = ".$productShouldBeAvailable * $storesReps.", Maerkte = ".$storesReps.", totale Verf. = ".$totalProductAvailability."]";
										}
									}
								}
								//}	($storesReps > 0)
							}// if ($closedround["Closedround"]["round_id"] == $round["Round"]["id"])
						}// $closedrounds
						
						if ($closedroundCnt > 0) { // für division by zero
						
							// dividiert durch geschlossene Rundenanzahl da ja Stockchecks über alle Runden hinweg gezählt wird, *100 da in Prozent
							$statistics[$roundName]["availability"] = ($totalProductAvailability/$closedroundCnt) * 100; 
						} else {
							$statistics[$roundName]["availability"] = 0;
						}
						//Summe über alle Verfügbarkeiten pro KW werden hier ermittelt
						$sumTotalProductAvailabilityRound = $sumTotalProductAvailabilityRound + $statistics[$roundName]["availability"];
						
						// Wenn die Verfügbarkeit einer Runde 0 ist dh. wenn keine Aufträge(Tasks) für einen Markt abgegeben wurden oder wenn noch keine Runde für einen Markt
						// in der aktuellen KW abgeschlossen wurde, wird ader Rundencounter nicht erhöht.
						if ($statistics[$roundName]["availability"] != 0) {
							$roundCnt++;
						}
						
					}//$rounds
					
					if ($roundCnt > 0) { // für division by zero
						$sumOfTotalProductAvailability["totalAvailability"] = $sumTotalProductAvailabilityRound/$roundCnt;
					} else {
						$sumOfTotalProductAvailability["totalAvailability"] = 0;
					}
					
					
				}//Zeitspanne über einem Jahr?
			}// isset submit
		}
		//print_r($query);
		//print_r($statistics);
		$this->set(compact('statistics'));
		$this->set(compact('sumOfTotalProductAvailability'));
	}
	
	
	
	
	
	function avgsalesvolumeperrep() {
		
		if ($this->requireAccess(true, array("accountmanager"))) {
			//Alle Hersteller werden berücksichtig egal ob sie dem Accoumanager zu diesem Zeitpunkt bereits zugeteilt waren
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			//Alle Runden werden berücksichtig bis(inklusive) zur aktuellen KW
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().") order by uts_round_until desc "  );
			$this->set(compact('rounds'));
			//$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			
			$this->set(compact('selectedroundid'));
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$statistics = array(); //im statistics array werden alle extrahierten Daten gespeichert
						
			if(isset($_REQUEST['submit'])) {
				
				$selectedroundfromid = @$_REQUEST['selectedroundfromid'];
				$this->set(compact('selectedroundfromid')); //für Sticky
				$selectedrounduntilid = @$_REQUEST['selectedrounduntilid'];
				$this->set(compact('selectedrounduntilid')); //für Sticky
				
				foreach($rounds as $round) {
					//Uts_round_from der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedroundfromid) {
						$utsRoundFrom = $round["Round"]["uts_round_from"];
					}
					//Uts_round_until der ausgewählten Runde wird rausgefiltert
					if ($round["Round"]["id"] == $selectedrounduntilid) {
						$utsRoundUntil = $round["Round"]["uts_round_until"];
					}
				}
				
				//****************** Auswertung Umsatz/Stunde SalesRep ************************
				// Hier wird nicht berücksichtig ob eine Runde bereits geschlossen wurde oder nicht es werden alle eingegebenen Daten gewertet
				$statistics = $this->Report->query("
				SELECT User.first_name, User.last_name, Report.user_id, Report.promotionsCnt, Report.totalWorkingtime, Report.averageWorkingtime, orders.totalsum, 
				orders.totalsum / (Report.totalWorkingtime / 60) AS salesVolumePerHour
			
				FROM  aclusersmanufacturers AS Aclusersmanufacturer
				LEFT JOIN users AS User ON (User.id = Aclusersmanufacturer.user_id)
				LEFT JOIN 
					(SELECT user_id, COUNT(id) AS promotionsCnt, SUM(jubduration) AS totalWorkingtime, SUM(jubduration) / COUNT(id) AS 	averageWorkingtime
					FROM reports 
					WHERE isEnabled='y' AND manufacturer_id =".$selectedmanufacturerid." AND uts_workingtime >=".$utsRoundFrom." AND uts_workingtime <= ".$utsRoundUntil."
					GROUP BY user_id ) AS Report ON (Report.user_id = User.id) 
				LEFT JOIN 	
					(SELECT orderer_id, SUM(totalsum) as totalsum
					FROM orders
					WHERE isEnabled ='y'
					GROUP BY orderer_id) AS orders ON (orders.orderer_id = User.id)
				
				WHERE Aclusersmanufacturer.manufacturer_id =".$selectedmanufacturerid." AND User.role_id = 2
				GROUP BY User.id 
				ORDER BY User.last_name
				");
				
				//print_r($statistics);
			}
			$this->set(compact('statistics'));	
		}
	}	
	
}


function helper_sort_rep_ranking($a, $b) {
	return $a["availability"] < $b["availability"];
}
function microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}
?>
