<?php
class Report extends AppModel
{
    var $name = 'Report';
	var $belongsTo= array(

		'Csvstore' =>
		array('className'    => 'Csvstore'),

		'User' =>
		array('className'    => 'User',
			  'foreignKey'   => 'user_id'),


		'Manufacturer' =>
		array('className'    => 'Manufacturer',
			  'foreignKey'   => 'manufacturer_id'),


	);

	//var $uses= array("Closedround");

	function beforeValidate() {
		// report kann dann gespeichert werden, wenn
		// 1. die runde nicht bereits abgeschlossen ist und
		// 2. kein aktiver (d.h. isEnabled='y') report für diesen markt, hersteller und store vorliegt
		//$this->isRoundStillOpen();
		//$this->isReportAlreadyPresent();
	}
	
	
	function isRoundStillOpen() {
		if (isset($this->data["Report"])) {
			$closedround = new Closedround();
			if ($closedround->isClosed($this->data["Report"]["round_id"], $this->data["Report"]["manufacturer_id"])) {
				$this->invalidate("roundstillopen", "Diese Runde ist bereits abgeschlossen");
			}
		}
	}


	
	function getNumReports($round_id, $manufacturer_id, $csvstore_id) {
		$reports = $this->findAll("Report.isEnabled='y' and round_id=".$round_id." and manufacturer_id=".$manufacturer_id." and csvstore_id=".$csvstore_id);
		return sizeof($reports);		
	}
	
	function getNumDeactivatedReports($round_id, $manufacturer_id, $csvstore_id) {
		$reports = $this->findAll("Report.isEnabled='n' and round_id=".$round_id." and manufacturer_id=".$manufacturer_id." and csvstore_id=".$csvstore_id);
		return sizeof($reports);		
	}
	
	
	function isReportAlreadyPresent() {
	
		$reports=array();
		// will der user den report bearbeiten oder neu anlegen?
		if (isset($this->data["Report"]["id"])) {
			$reports = $this->find("Report.id=" . $this->data["Report"]["id"]);
		}
		if(!empty($reports)) {
			// user will den report bearbeiten
		} else {
			// user will einen neuen report eingeben
			$reports = $this->find("Report.isEnabled='y' and round_id=" .  $this->data["Report"]["round_id"] . " and manufacturer_id=" . $this->data["Report"]["manufacturer_id"]  . " and csvstore_id=". $this->data["Report"]["csvstore_id"]);
				
				
				
			if(!empty($reports)) {
				$this->invalidate("reportalreadypresent", "Für diese Runde, Hersteller und Markt wurde bereits ein Report eingegeben");
			}
		}
	}

	var $validate = array(


		'uts_workingtime' => array(
            'rule' => array('minLength', '1'),
            'message' => 'Bitte geben Sie das Einsatzdatum ein.'
        ),
		'headofdepartment' => array(
            'rule' => array('minLength', '1'),
            'message' => 'Bitte geben Sie den Abteilungsleiter ein.'
        ),
		'jubduration' => array(
            'rule' => array('alphaNumeric'),
            'message' => 'Bitte geben Sie die Dauer der Marktzeit ein.'
        ),
		'rackwidth' => array(
        	'rule' => array('minLength', 1),
       		'message' => 'Bitte geben Sie die Anzahl der Regalmeter ein.'
		),
		'totalrackwidth' => array(
            'rule' => array('minLength', 1),
            'message' => 'Bitte geben Sie die Anzahl der Regalmeter ein.'
		),

		'sonderjubduration' => array(
            'rule' => array('alphaNumeric'),
            'message' => 'Bitte geben Sie die Dauer des Sonderjobs ein.'
		),

		'report' => array(
            'rule' => array('minLength', '1'),
            'message' => 'Bitte geben Sie Ihren Report ein.'
		),
		
		'journey_time' => array(
            'rule' => array('alphaNumeric'),
            'message' => 'Bitte geben Sie die Dauer der Fahrtzeit ein.'
		),
		
		'wrap_up' => array(
            'rule' => array('alphaNumeric'),
            'message' => 'Bitte geben Sie die Nachbereitungszeit ein.'
		),

		'scheduling' => array(
            'rule' => array('alphaNumeric'),
            'message' => 'Bitte geben Sie die Dauer die Vorbereitungszeit ein.'
		),


    );



}
?>
