<?php
class Stockcheck extends AppModel
{
    var $name = 'Stockcheck';
	
	
	var $belongsTo= array('Csvproduct' =>
                        array('className'    => 'Csvproduct',
                              'conditions'   => '',
                              'order'        => '',
                              'foreignKey'   => 'csvproduct_id'
                        ),
						'Round' =>
                        array('className'    => 'Round',
                              'conditions'   => '',
                              'order'        => '',
                              'foreignKey'   => 'round_id'
                        ),
						'Csvstore' =>
                        array('className'    => 'Csvstore',
                              'conditions'   => '',
                              'order'        => '',
                              'foreignKey'   => 'csvstore_id'
                        ),
						
	);
	
	var $validate = array(
		'retail_price' => array(
            'rule' => array('commentOrDataAvailable', 'retail_price'),
			'message' => 'Bitte geben Sie den VK-Preis ein.'
		),
		'stock' => array(
            'rule' => array('commentOrDataAvailable', 'stock'),
			'message' => 'Bitte geben Sie den aktuellen Lagerstand ein.'
		),
		'quantity' => array(
            'rule' => array('commentOrDataAvailable', 'quantity'),
			'message' => 'Bitte geben Sie die Bestellmenge ein.'
		),
		
		'comment' => array(
            'rule' => array('commentOrDataAvailable', "comment"),
			'message' => 'Oder geben Sie einen Kommentar ein.'
		),
		
    );
	
	// liefert true zurck wenn das feld OK ist, d.h. in die db geschrieben werden darf
	//         false zurck wenn das feld NICHT OK war, d.h. wenn er es nicht in die db schreiben darf
	function commentOrDataAvailable($data, $field){
		//print_r($this->data);
 		if (trim($this->data["Stockcheck"]["comment"]) != "") {
			// kommentar wurde eingegeben, alles roger!
			return true;
		}
		$err=array();
		
		// default: wir nehemn an dass das produkt 0EUR oder mer kostet
		$err["retail_price"] = $this->data["Stockcheck"]["retail_price"] >=0 ;
		if ( (int)$this->data["Stockcheck"]["retail_price"] == 0) {
			$csvproduct = $this->query("select * from csvproducts where id=".$this->data["Stockcheck"]["csvproduct_id"]);
			if ($csvproduct[0]["csvproducts"]["shouldBeChecked"] == "y") {
				// ja, produkt muss kontrolliert werden und es wurde kein preis eingegeben -> das darf lt. issue 114 nicht sein
				$err["retail_price"] = false;
			}
		}
		
		
		$err["stock"] = $this->data["Stockcheck"]["stock"] >=0 ;
		
		// default: wir nehmen  mal an dass das produkt noch auf lager ist, d.h. es muss nicht unbedingt bestellt werden
		$err["quantity"] = $this->data["Stockcheck"]["quantity"] >= 0 ;
		if ( (int)$this->data["Stockcheck"]["stock"] == 0) {
			// produkt ist doch nicht auf lager rep muss bestellen falls es ein a-produkt ist
			$csvproduct = $this->query("select * from csvproducts where id=".$this->data["Stockcheck"]["csvproduct_id"]);
//print_r($csvproduct);
			if ($csvproduct[0]["csvproducts"]["shouldBeChecked"] == "y") {
				// ja, produkt muss kontrolliert werden und es wurde nichts bestellt -> das ist ein fehler!
				$err["quantity"] = $this->data["Stockcheck"]["quantity"] > 0 ;
			}
		}
		
		
		
		// *********** wenn einer der 3 werte fehlerhaft war, soll die meldung: "oder geben sie einen kommentar ein" erscheinen
		
		$err["comment"] = true; // default: keine fehlermeldung ausgeben
		if ($err["quantity"] && $err["retail_price"] && $err["stock"]) {
			// alles ok, keine fehlermeldung
		} else {
			// einer der 3 werte hat nicht gepasst: fehlermeldung bei kommentar anzeigen
			$err["comment"] = false;
		}
		// *********** wenn einer der 3 werte fehlerhaft war, soll die meldung: "oder geben sie einen kommentar ein" erscheinen
		
		return $err[$field];
	}
	
}
?>